// htmlArea v3.0 - Copyright (c) 2002-2004 interactivetools.com, inc.
// This copyright notice MUST stay intact for use (see license.txt).
//
// Portions (c) dynarch.com, 2003-2004
//
// A free WYSIWYG editor replacement for <textarea> fields.
// For full source code and docs, visit http://www.interactivetools.com/
//
// Version 3.0 developed by Mihai Bazon.
//   http://dynarch.com/mishoo
//
// Portions (c) Copyright 2004,2005 SWsoft, Inc. http://www.swsoft.com
//
var clippboardval;
var mvContent;
var vFirst;
var vLast;
var vLength;
var vURL;
var elb
var els;
var elf;
var win=null;
var upload=false;

function HTMLArea(textarea, config) {
	if (HTMLArea.checkSupportedBrowser()) {
		if (typeof config == "undefined") {
			this.config = new HTMLArea.Config();
		} else {
			this.config = config;
		}
		this._htmlArea = null;
		this._textArea = textarea;
		this._editMode = "wysiwyg";
		this.plugins = {};
		this._timerToolbar = null;
		this._mdoc = document;
		this._timerUndo = null;
		this._applayUndo = true;
		this._undoQueue = new Array(this.config.undoSteps);
		this._undoPos = -1;
		this._customUndo = true;
		this.doctype = '';
	}
};

HTMLArea.RE_tagName = /(<\/|<)\s*([^ \t\n>]+)/ig;
HTMLArea.RE_doctype = /(<!doctype((.|\n)*?)>)\n?/i;
HTMLArea.RE_head	= /<head>((.|\n)*?)<\/head>/i;
HTMLArea.RE_body	= /<body>((.|\n)*?)<\/body>/i;

function fMessage(strVal) {
	var retVal;
	try {
		retVal=Lang[strVal];
	} catch (e) {
		//retVal="undefined";
	}

	if (!retVal || typeof retVal == "undefined" || retVal == "") {
		retVal="[" + strVal + "]";
	}
	return retVal;
};

HTMLArea.Config = function () {
	this.version = "3.0";
	this.width = "auto";
	this.height = "auto";
	this.statusBar = true;
	this.sizeIncludesToolbar = true;
	this.pageStyle = "body { background-color: #fff; font-family: verdana,sans-serif; }";
	this.editorURL = getSiteUrl();
	this.imgURL = "/images/";
	this.popupURL = "/wysiwyg/popups/";
	this.plugins = {};
	this.SiteUrl = getSiteUrl();
	this.toolbar = [
		[ "fontname", "space", "fontsize", "space",
		"formatblock", "separator", "forecolor", "hilitecolor", "separator",
		"bold", "italic", "underline", "strikethrough", "subscript", "superscript","insertsymbol", "separator",
		"justifyleft", "justifycenter", "justifyright", "justifyfull", "separator","outdent", "indent",
		"separator", "shbord","separator", "save", "fullscreen", "sb_100"],

		["linebreak"],

		[ "cut", "copy", "paste","finde", "spell", "selectall", "separator", "undo", "redo", "separator",
		"insertimage", "createlink",  "inserthorizontalrule",
		"separator", "insertorderedlist", "insertunorderedlist",  "separator", "inserttable"]
	];

	this._testFont=document.getElementById("SB_TEST_DIV");
	this._testFontT=document.getElementById("SB_TEST_TABLE");
	this._testFontF=document.getElementById("SB_TEST_FONT");
	this._testFont.style.fontFamily="times";
	var tdw=this._testFont.scrollWidth;
	var tdh=this._testFont.scrollHeight;
	var ht=tdh;
	var wt=tdw;
	this.fontname = {
		"":		   "none"
	};

	this._testFont.style.fontFamily="arial";
	this.fontname["Arial"]="arial";
	this._testFont.style.fontFamily="none";
	wt=this._testFont.scrollWidth;
	ht=this._testFont.scrollHeight;
	this._testFont.style.fontFamily="courier";
	this.fontname["Courier New"]="courier";
	this._testFont.style.fontFamily="georgia";
	this.fontname["Georgia"]="georgia";

	if (HTMLArea.is_ie) {
		this.fontname["Tahoma"]="tahoma";
	} else {
		this._testFont.style.fontFamily="tahoma";
		if ((tdw+" - "+tdh == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight) ||
			(wt+" - "+ht == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight)) {
		} else {
			this.fontname["Tahoma"]="tahoma";
		}
	}
	this._testFont.style.fontFamily="helvetica";
	if ((tdw+" - "+tdh == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight) || (wt+" - "+ht == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight)) {
	} else {
		this.fontname["Helvetica"]="helvetica";
	}
	this.fontname["Times New Roman"]="times";
	this._testFont.style.fontFamily="times";
	this._testFont.style.fontFamily="verdana";
	this.fontname["Verdana"]="verdana";
	this._testFont.style.fontFamily="impact";
	if ((tdw+" - "+tdh == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight) ||
		(wt+" - "+ht == this._testFont.scrollWidth+" - "+this._testFont.scrollHeight)) {
	} else {
		this.fontname["Impact"]="impact";
	}
	this._testFont.style.display="none";
	this._testFontT.style.display="none";
	this.fontsize = {
		"": "none",
		"1 (8 pt)":  "1",
		"2 (10 pt)": "2",
		"3 (12 pt)": "3",
		"4 (14 pt)": "4",
		"5 (18 pt)": "5",
		"6 (24 pt)": "6",
		"7 (36 pt)": "7"
	};
//var head1=fMessage("heading1");

	this.formatblock = { "" : "none" };
	this.formatblock[fMessage("normal")] = "p";
	this.formatblock[fMessage("heading1")] = "h1";
	this.formatblock[fMessage("heading2")] = "h2";
	this.formatblock[fMessage("heading3")] = "h3";
	this.formatblock[fMessage("heading4")] = "h4";
	this.formatblock[fMessage("heading5")] = "h5";
	this.formatblock[fMessage("heading6")] = "h6";
	this.formatblock[fMessage("address")] = "address";
	this.formatblock[fMessage("formatted")] = "pre";
//		"": "none",
//		"Normal": "p",
//		"": "h1",
//		"Heading 2": "h2",
//		"Heading 3": "h3",
//		"Heading 4": "h4",
//		"Heading 5": "h5",
//		"Heading 6": "h6",
//		"Address": "address",
//		"Formatted": "pre"
//	};

	this.customSelects = {};

	function cut_copy_paste(e, cmd, obj) {
		if (cmd=="copy") {
			if (/type=([\"|\'])modules([\"|\'])/i.test(editor.getSelectedHTML())) {
				alert(fMessage("notallowedoperation"));
				return false;
			}
		}
		try {
			e.execCommand(cmd);
		} catch (e) {
			if (HTMLArea.is_gecko) {
				alert(fMessage("cut_copy_paste"));
				for (var i in editor._toolbarObjects) {
					var btn = editor._toolbarObjects[i];
					if (btn.name=="cut" || btn.name=="copy" || btn.name=="paste") {
						btn.element.style.display = "none";
					}
				}
			}
		}
	};

	this.btnList = {
		bold: [ fMessage("bold"), "wysiwyg/images/ed_format_bold.gif", false, false, true, function(e) {e.execCommand("bold");}, "style" ],
		italic: [ fMessage("italic"), "wysiwyg/images/ed_format_italic.gif", false, false, true, function(e) {e.execCommand("italic");}, "style" ],
		underline: [ fMessage("underline"), "wysiwyg/images/ed_format_underline.gif", false, false, true, function(e) {e.execCommand("underline");}, "style" ],
		strikethrough: [ fMessage("strikethrough"), "wysiwyg/images/ed_format_strike.gif", false, false, true, function(e) {e.execCommand("strikethrough");}, "style" ],
		subscript: [ fMessage("subscript"), "wysiwyg/images/ed_format_sub.gif", false, false, true, function(e) {e.execCommand("subscript");}, "style" ],
		superscript: [ fMessage("superscript"), "wysiwyg/images/ed_format_sup.gif", false, false, true, function(e) {e.execCommand("superscript");}, "style" ],
		justifyleft: [ fMessage("justifyleft"), "wysiwyg/images/ed_align_left.gif", false, false, true, function(e) {e.execCommand("justifyleft");} ],
		justifycenter: [ fMessage("justifycenter"), "wysiwyg/images/ed_align_center.gif", false, false, true, function(e) {e.execCommand("justifycenter");} ],
		justifyright: [ fMessage("justifyright"), "wysiwyg/images/ed_align_right.gif", false, false, true, function(e) {e.execCommand("justifyright");} ],
		justifyfull: [ fMessage("justifyfull"), "wysiwyg/images/ed_align_justify.gif", false, false, true, function(e) {e.execCommand("justifyfull");} ],
		insertorderedlist: [ fMessage("orderedlist"), "wysiwyg/images/ed_list_num.gif", false, false, true, function(e) {e.execCommand("insertorderedlist");}, "list" ],
		insertunorderedlist: [ fMessage("bulletedlist"), "wysiwyg/images/ed_list_bullet.gif", false, false, true, function(e) {e.execCommand("insertunorderedlist");}, "list" ],
		outdent: [ fMessage("decreaseindent"), "wysiwyg/images/ed_indent_less.gif", false, false, true, function(e) {e.execCommand("outdent");} ],
		indent: [ fMessage("increaseindent"), "wysiwyg/images/ed_indent_more.gif", false, false, true, function(e) {e.execCommand("indent");} ],
		forecolor: [ fMessage("fontcolor"), "wysiwyg/images/ed_color_fg.gif", false, false, true, function(e) {e.execCommand("forecolor");}, "forecolor" ],
		hilitecolor: [ fMessage("backgroundcolor"), "wysiwyg/images/ed_color_bg.gif", false, false, true, function(e) {e.execCommand("hilitecolor");}, "hilitecolor" ],
		inserthorizontalrule: [ fMessage("horizontalrule"), "wysiwyg/images/ed_hr.gif", false, false, true, function(e) {e.execCommand("inserthorizontalrule");}, "hr" ],
		createlink: [ fMessage("insertweblink"), "wysiwyg/images/ed_link.gif", false, false, true, function(e) {e.execCommand("createlink", true);}, "createlink" ],
		insertimage: [ fMessage("insertimage"), "wysiwyg/images/pic.gif", false, false, true, function(e) {e.execCommand("insertimage");}, "insertimage" ],
		inserttable: [ fMessage("inserttable"), "wysiwyg/images/insert_table.gif", false, false, true, function(e) {e.execCommand("inserttable");} ],
		undo: [ fMessage("undo"), "wysiwyg/images/ed_undo.gif", false, false, true, function(e) {e.execCommand("undo");}, "undo"],
		redo: [ fMessage("redo"), "wysiwyg/images/ed_redo.gif", false, false, true, function(e) {e.execCommand("redo");}, "redo"],
		cut: [ fMessage("cut"), "wysiwyg/images/ed_cut.gif", false, false, true, cut_copy_paste ],
		copy: [ fMessage("copy"), "wysiwyg/images/ed_copy.gif", false, false, true, cut_copy_paste ],
		paste: [ fMessage("paste"), "wysiwyg/images/ed_paste.gif", false, false, true, cut_copy_paste ],
		selectall: [ fMessage("selectall"), "wysiwyg/images/selectall.gif", false, false, true, function(e) {e.execCommand("selectall");} ],
		insertsymbol: [ fMessage("insertsymbol"), "wysiwyg/images/symbols.gif", false, false, true, function(e) {e.execCommand("insertsymbol");}, "symbol" ],
		finde: [ fMessage("findereplace"), "wysiwyg/images/find.gif", false, false, true, function(e) {e.execCommand("finde");} ],
		spell: [ fMessage("checkspelling"), "wysiwyg/images/spellcheck.gif", false, false, true, function(e) {e.execCommand("spell");} ],
		shbord: [ fMessage("showborders"), "wysiwyg/images/show-borders.gif", false, false, true, function(e) {e.execCommand("shbord");} ],
		save: [ fMessage("save"), "wysiwyg/images/ed_save.gif", false, false, true, function(e) {doSave(true);} ],
		fullscreen: [ fMessage("fullscreen"), "wysiwyg/images/ed_fs.gif", false, false, true, function(e) {e.execCommand("fullscreen");} ]
	};
};

HTMLArea.replaceAll = function(config) {
	var tas = document.getElementsByTagName("textarea");
	for (var i = tas.length; i > 0; (new HTMLArea(tas[--i], config)).generate());
};

HTMLArea.replace = function(id, config) {
	var ta = document.getElementById(id);
	return ta ? (new HTMLArea(ta, config)).generate() : null;
};

function setWidth() {
	var p = editor._iframe;
	while (p.tagName.toLowerCase() != 'body') {
		p=p.parentNode;
		if (p.tagName.toLowerCase() == 'td') {
			if ((p.style.width != '' && p.style.width != 'undefined')) {
				editor.width = parseInt(p.style.width)+"px";
				break;
			}
			if ((p.width != '' && p.width != 'undefined')) {
				editor.width = parseInt(p.width)+"px";
				break;
			}
		}
	}
	if (parseInt(editor.width)<250) {
		editor.width="500px";
	}
}

function fSetSB(html) {
	var s;
	s=editor.mvContAll;
	return s;
}

this._divW=0;
this._divH=0;

function init() {
	try{
		editor.updateToolbar();
		editor.focusEditor();
		if (HTMLArea.is_ie) {
			if (parseInt(editor._doc.body.scrollHeight+editor._doc.body.scrollTop+ 20)<80) {
				editor._iframe.style.height = 400+"px";
			} else {
				editor._iframe.style.height = editor._doc.body.scrollHeight+editor._doc.body.scrollTop+ 20 + "px";
			}
			editor._iframe.style.width = editor.width;
			for(var i=0; i<editor._TD.length; i++) {
				editor._TD[i].style.height = "400px";
			}
		} else {
			if (parseInt(editor._doc.body.scrollHeight+editor._doc.body.scrollTop+ 20)<80) {
				editor._iframe.style.height = 400+"px";
			} else {
				editor._iframe.style.height = editor._doc.body.scrollHeight+editor._doc.body.scrollTop+ 20 + "px";
			}
			editor._iframe.style.width = "100%";
			for(var i=0; i<editor._TD.length; i++) {
				editor._TD[i].style.height = "400px";
			}
		}
	}catch(e) {
	}
}

function initIframe() {
	doc = editor._iframe.contentWindow.document;
	if (!doc) {
		if (HTMLArea.is_gecko) {
			setTimeout(initIframe, 100);
			return false;
		} else {
			alert(fMessage("error")+ " " + fMessage("iframeinitialised"));
		}
	}
	if (HTMLArea.is_gecko) {
		try{
			if (editor.mvPType=="HTML") {
				doc.designMode = "on";
			} else {
				doc.designMode = "off";
			}
		}catch(e) {
		}
	}

	var vBod;
	if (typeof mvContent != "undefined") {
		vBod = getBody(mvContent);
	} else {
		vBod = editor._textArea.value;
	}
	var tmpFirst=editor.first;
	try{
		var bod=tmpFirst.match(/<body(.*?)>/gim);
	}catch(e) {
		var bod=false;
	}
	if (typeof tmpFirst != "undefined") {
		tmpFirst=editor.first.replace(/<base(.*?)>/gim,"");
		tmpFirst=tmpFirst.replace(/<body(.*?)>/gim,"");
		tmpFirst=tmpFirst.replace("/<html>/gim","");
		tmpFirst=tmpFirst.replace("/<head>/gim","");
		tmpFirst=tmpFirst.replace("/<\/head>/","");
	} else {
		tmpFirst="";
	}
	editor._doc = doc;
	if (editor.mvPType=="HTML") {
		try{
			editor._doc.queryCommandValue("formatblock");
		}catch(e) {
			dc(1);
			document.forms[0].submit();
			return false;
		}
	}
	editor._doc.open();
	var html="";
	html += "<html>\n";
	html += "<head>\n";
	html += editor.base;
	html += editor.style;
	html += "\n";
	html += tmpFirst;
	html += "<style>\n";
	if (editor.showborders==true) {
		html += "TD {border-width: 1px; border-style: dashed; border-color: #cccccc;}\n";
	}
	html += "form {border-width: 1px; border-style: dashed; border-color: #00ff00;}\n";
	html += "</style>\n";
	html += setStyle();
	html += "</head>\n";
	if (bod) {
		html += "<body class='pageContent' style='background-color:transparent; margin-left: 1px;margin-top: 0px;margin-right: 0px;margin-bottom: 0px;'>";
	} else {
		html += "<body class='pageContent' style='background-color:transparent; margin-left: 1px;margin-top: 0px;margin-right: 0px;margin-bottom: 0px;'>";
	}
	if (editor.bod=="undefined" || typeof editor.bod=="undefined") {
	} else {
		html += delEmptyTag(editor.bod);
	}
	html += "</body>\n";
	html += "</html>";
	editor._doc.write(html);
	editor._doc.close();
	if (HTMLArea.is_ie) {
		if (editor.mvPType=="HTML") {
			editor._doc.body.contentEditable = true;
		} else {
			editor._doc.body.contentEditable = false;
		}
	} else {
		try{
			if (editor.mvPType=="HTML") {
				if (editor._doc.designMode=="off") editor._doc.designMode = "on";
			}
		}catch(e) {
		}
	}
	if (HTMLArea.is_ie) {
		HTMLArea._addEvents(editor._doc, ["dblclick", "keydown","keyup", "keypress", "mousedown", "mouseup", "dragstart"],
		function (event) {
			return editor._editorEvent(HTMLArea.is_ie ? editor._iframe.contentWindow.event : event);
		});
	 } else {
		HTMLArea._addEvents(editor._doc, ["dblclick", "keydown", "keyup", "keypress", "click", "mousedown", "mouseup", "dragdrop"],
		function (event) {
			return editor._editorEvent(HTMLArea.is_ie ? editor._iframe.contentWindow.event : event);
		});
	}
	editor.SelNode = editor._doc.body;
	editor.updateToolbar();
	editor.focusEditor();
};

function setStyle() {
	var s="";
	for(var t=0;t < editor.mvRep.length;t++)
	{
		if (editor.mvRep[t].substr(editor.mvRep[t].length-3,3)=='css') {
			s=s+'<style type="text/css">@import url('+editor.url+editor.mvRep[t]+');</style>';
		}
	}
	return s;
}

var hg;
var doc;
var docp;
var iframep;
var mvMode;


HTMLArea.loadPlugin = function(pluginName) {
	var dir = getSiteUrl() + "/wysiwyg/plugins/" + pluginName;
	var plugin = pluginName.replace(/([a-z])([A-Z])([a-z])/g,
		function (str, l1, l2, l3) {
				return l1 + "-" + l2.toLowerCase() + l3;
		}).toLowerCase() + ".js";
	document.write("<script type='text/javascript' src='" + dir + "/" + plugin + "'></script>");
};

function fAddEventOnElement(el) {
	editor.selectNodeContent(el);
};

function setPT(val) {
	switch(val) {
		case "1" :
				return "8pt";
				break;
		case "2" :
				return "10pt";
				break;
		case "3" :
				return "12pt";
				break;
				case "4" :
				return "14pt";
				break;
		case "5" :
				return "18pt";
				break;
		case "6" :
				return "24pt";
				break;
		case "7" :
				return "36pt";
				break;
		default: return "";
	}
}

function delHref(html) {
	if (editor.base=="" || typeof editor.base == "undefined") {
		return html;
	} else {
		return html.substr(editor.base.length,html.length-editor.base.length);
	}
}

function getBody(html) {
	mvContent=html;
	var bodytag;
	var re=/<body([\s\S]*?)<\/body>/gim;
	var L1;
	var t;
	t=html.match(re);
	if (t) {
		bodytag=re.exec(html);
		if (HTMLArea.is_ie) {
			var L=t.index;
			var R=t[0].length+L;
		} else {
			var L=bodytag.index;
			var R=bodytag[0].length+L;
		}

		var D=html.length;
		if (L==0) {
			L=0 ; R=D;
		} else {
			for(var i=L;i<R;i++) {
				if (html.substr(i,1)==">") {
					L1=i+1;
					break;
				}
			}
			L=L1;
			R1=R-7;
			R=R1;
			if (R==0) {
				R=D;
			}
		}
		vFirst=html.substr(0, L);
		vLast=html.substr(R, D-R);
		editor.first=vFirst;
		html = html.substr(L, R-L)
		editor.bod=fAddVT(html);
		html = delEmptyTag(html);
		return fAddVT(html);
	} else {
		html = delEmptyTag(html);
		editor.bod=fAddVT(html);
		return fAddVT(html);
	}
};

function delEmptyTag(html) {
	var div = document.createElement("div");
	div.id = "body_div";
	try {
		div.innerHTML = html;
	} catch (e) {
		return html;
	}
	var ch=div.childNodes;
	for(var t=0; t<ch.length; t++) {
		try{
			var tag = ch[t].tagName.toLowerCase();
		}catch(e) {
			var tag = "none";
		}
		if (ch[t]=="[object Text]") {
				div.removeChild(ch[t]);
		}

	}
	var br = div.getElementsByTagName("br");
	for(var t=0; t<br.length; t++) {;
		if (br[t].parentNode.id=="body_div") {
				div.removeChild(br[t]);
		}
	}
	var br = div.getElementsByTagName("br");
	for(var t=0; t<br.length; t++) {;
		if (br[t].parentNode.id=="body_div") {
				div.removeChild(br[t]);
		}
	}
	html = div.innerHTML;
	return html;
}

var f;

function setBody(html) {
	if (vFirst && vFirst!="" && typeof vFirst!="undefined") {
	} else {
		vFirst="";
	}
	if (vLast && vLast!="" && typeof vLast!="undefined") {
	} else {
		vLast="";
	}
	return vFirst+fRemoveVT(html)+vLast;
};

function fAddVT(html) {
	return html;
};

function fRemoveVT(html) {
	return html;
};

HTMLArea.agt = navigator.userAgent.toLowerCase();
HTMLArea.is_ie = ((HTMLArea.agt.indexOf("msie") != -1) && (HTMLArea.agt.indexOf("opera") == -1));
HTMLArea.is_opera  = (HTMLArea.agt.indexOf("opera") != -1);
HTMLArea.is_mac = (HTMLArea.agt.indexOf("mac") != -1);
HTMLArea.is_mac_ie = (HTMLArea.is_ie && HTMLArea.is_mac);
HTMLArea.is_win_ie = (HTMLArea.is_ie && !HTMLArea.is_mac);
HTMLArea.is_gecko  = (navigator.product == "Gecko");

HTMLArea._object = null;
HTMLArea.checkSupportedBrowser = function() {
	if (HTMLArea.is_gecko) {
		if (navigator.productSub < 20021201) {
			alert(fMessage("mozilla13") + fMessage("sorrygecko"));
			return false;
		}
		if (navigator.productSub < 20030210) {
			alert(fMessage("mozilla13beta") + fMessage("trynotwork"));
		}
	}
	return HTMLArea.is_gecko || HTMLArea.is_ie;
};

HTMLArea._addEvent = function(el, evname, func) {
	if (HTMLArea.is_ie) {
		el.attachEvent("on" + evname, func);
	} else {
		el.addEventListener(evname, func, true);
	}
};

HTMLArea._addEvents = function(el, evs, func) {
	for (var i in evs) {
		HTMLArea._addEvent(el, evs[i], func);
	}
};

HTMLArea._removeEvent = function(el, evname, func) {
	if (HTMLArea.is_ie) {
		el.detachEvent("on" + evname, func);
	} else {
		el.removeEventListener(evname, func, true);
	}
};

HTMLArea._removeEvents = function(el, evs, func) {
	for (var i in evs) {
		HTMLArea._removeEvent(el, evs[i], func);
	}
};

HTMLArea._stopEvent = function(ev) {
	if (HTMLArea.is_ie) {
		ev.cancelBubble = true;
		ev.returnValue = false;
	} else {
		ev.preventDefault();
		ev.stopPropagation();
	}
};

HTMLArea._removeClass = function(el, className) {
	if (!(el && el.className)) {
		return;
	}
	var cls = el.className.split(" ");
	var ar = new Array();
	for (var i = cls.length; i > 0;) {
		if (cls[--i] != className) {
			ar[ar.length] = cls[i];
		}
	}
	el.className = ar.join(" ");
};

HTMLArea._addClass = function(el, className) {
	HTMLArea._removeClass(el, className);
	el.className += " " + className;
};

HTMLArea._hasClass = function(el, className) {
	if (!(el && el.className)) {
		return false;
	}
	var cls = el.className.split(" ");
	for (var i = cls.length; i > 0;) {
		if (cls[--i] == className) {
			return true;
		}
	}
	return false;
};

HTMLArea.isBlockElement = function(el) {
	var blockTags = " body form textarea fieldset ul ol dl li div " +
		"p h1 h2 h3 h4 h5 h6 quote pre table thead " +
		"tbody tfoot tr td iframe address ";
	return (blockTags.indexOf(" " + el.tagName.toLowerCase() + " ") != -1);
};

HTMLArea.needsClosingTag = function(el) {
	var closingTags = " script style div span tr td tbody table em strong font a ";
	return (closingTags.indexOf(" " + el.tagName.toLowerCase() + " ") != -1);
};

HTMLArea.isTag = function(el) {
	var Tag = " a abbr acronym address applet area b base basefont bdo big blockquote body br button caption center cite code col colgroup dd del dfn dir div dl dt em fieldset font form frame frameset h1 h2 h3 h4 h5 h6 head hr html i iframe img input ins isindex kbd label legend li link map menu meta nobr noframes noscript object ol optgroup option p param pre q s samp script select small span strike strong style sub sup table tbody td textarea tfoot th thead title tr tt u ul var ";
	return (Tag.indexOf(" " + el.tagName.toLowerCase() + " ") != -1);
};

HTMLArea.htmlEncode = function(str) {
	return str;
};

HTMLArea.htmlEncodeProp = function(str) {
	try{
		str = str.replace(/&/ig, "&amp;");
		str = str.replace(/</ig, "&lt;");
		str = str.replace(/>/ig, "&gt;");
		str = str.replace(/\x22/ig, "&#34;");
	}catch(e) {
	}
	return str;
};
HTMLArea.htmlEncodeProp1 = function(str) {
	try{
		//str = str.replace(/&/ig, "&amp;");
		//str = str.replace(/</ig, "&lt;");
		//str = str.replace(/>/ig, "&gt;");
		str = str.replace(/\x22/ig, "&quot;");
	}catch(e) {
	}
	return str;
};

HTMLArea.getHTML = function(root, outputRoot) {
	var html = "";
	var tn = "none";
	switch (root.nodeType) {
		case 1: // Node.ELEMENT_NODE
		case 11: // Node.DOCUMENT_FRAGMENT_NODE
			var closed;
			var i;
			if (outputRoot) {
				closed = (!(root.hasChildNodes() || HTMLArea.needsClosingTag(root)));
				if (HTMLArea.isTag(root)) {
					html = "<" + root.tagName.toLowerCase();
				} else {
					html = "&lt;" + root.tagName.toLowerCase();
				}
				tn = root.tagName.toLowerCase();
				var attrs = root.attributes;
				for (i = 0; i < attrs.length; ++i) {
					var a = attrs.item(i);
					if (!a.specified) {
						continue;
					}
					var name = a.nodeName.toLowerCase();
					if (/_moz/.test(name)) {
						continue;
					}
					var value;
					if (name != "style") {
						try{
							if (typeof root[a.nodeName] != "undefined") {
								value =  HTMLArea.htmlEncodeProp(root[a.nodeName]);
							} else {
								value =  HTMLArea.htmlEncodeProp(a.nodeValue);
							}
						}catch(e) {
							value =  HTMLArea.htmlEncodeProp(a.nodeValue);
						}
					} else {
						value = root.style.cssText;
					}
					if (/_moz/.test(value)) {
						continue;
					}
					if (HTMLArea.isTag(root)) {
						html += " " + name + '="' + HTMLArea.htmlEncodeProp1(value) + '"';
						try{
							if (HTMLArea.is_ie && (root.title != "" && root.title != "undefined" && typeof root.title != "undefined")) {
								//html += ' title="' + HTMLArea.htmlEncodeProp(root.title) + '"';
							}
						}catch(e) {
						}
					} else {
						html += name + value;
					}
				}
				if (root.tagName.toLowerCase()=="base" || root.tagName.toLowerCase()=="input" || root.tagName.toLowerCase()=="textarea" || root.tagName.toLowerCase()=="option" || root.tagName.toLowerCase()=="img" || root.tagName.toLowerCase()=="br") {
					if (HTMLArea.isTag(root)) {
						html += ">";
					}
				} else {
					if (HTMLArea.isTag(root)) {
						html += closed ? " />" : ">";
					} else {
						html += "&gt;";
					}
				}
			}
			for (i = root.firstChild; i; i = i.nextSibling) {
				html += HTMLArea.getHTML(i, true);
			}
			if (outputRoot && !closed) {
				if (HTMLArea.isTag(root)) {
					html += "</" + root.tagName.toLowerCase() + ">";
				}
			}
			break;
		case 3: // Node.TEXT_NODE
			html = HTMLArea.htmlEncode(root.data);
			if (root.data != "" && root.data != "\n" && root.data != " ") {
				arrData[idd]=root;
				arrElement[idd]=root.parentNode;
				idd++;
			}

			html=html.replace('&','&amp;');
			while(html.match('<') != null) {
				html=html.replace('<','&lt;');
			}
			while(html.match('>') != null) {
				html=html.replace('>','&gt;');
			}
			break;
		case 8: // Node.COMMENT_NODE
			html = "<!--" + root.data + "-->";
			break;
	}
	return html;
};

var idd=0;
var arrData=new Array;
var arrElement=new Array;

HTMLArea._makeColor = function(v) {
	if (typeof v != "number") {
		return v;
	}
	var r = v & 0xFF;
	var g = (v >> 8) & 0xFF;
	var b = (v >> 16) & 0xFF;
	return "rgb(" + r + "," + g + "," + b + ")";
};

HTMLArea._colorToRgb = function(v) {
	function hex(d) {
		return (d < 16) ? ("0" + d.toString(16)) : d.toString(16);
	};

	if (typeof v == "number") {
		var r = v & 0xFF;
		var g = (v >> 8) & 0xFF;
		var b = (v >> 16) & 0xFF;
		return "#" + hex(r) + hex(g) + hex(b);
	}
	try{
		if (v.substr(0, 3) == "rgb") {
			var re = /rgb\s*\(\s*([0-9]+)\s*,\s*([0-9]+)\s*,\s*([0-9]+)\s*\)/;
			if (v.match(re)) {
				var r = parseInt(RegExp.$1);
				var g = parseInt(RegExp.$2);
				var b = parseInt(RegExp.$3);
				return "#" + hex(r) + hex(g) + hex(b);
			}
			return null;
		}
		if (v[0] == "#") {
			return v;
		}
	}catch(e) {
	}
	return null;
};

var myObject = new Object();
function oWord(pos, wrd, node) {
	this.id = pos;
	this.word = wrd;
	this.node = node;
	this.stat = '';
}


function setPPHTML() {
	if (strText!="&#160;") {
		if (editor._PG) {
			editor._PGO.innerHTML=strText;
		} else {
			editor.insertHTML('<div id="SB_photo" name="'+editor.ppID+'" style="width: 100%;">'+strText+'</div>');
		}
	}
};


function getCoordinateValue(name, temp) {
	if (temp == null || temp == "undefined" || temp == "") {
		temp="none";
	}
	if(document.getElementsByName(name).item(0)) {
		document.getElementsByName(name).item(0).value=temp;
	}
	return temp;
}

HTMLArea.HERE=getSiteUrl()+"/wysiwyg/";
function doEncodeTagp(str) {
	try{
		str = str.replace(/&/ig, "&amp;");
		while(str.match(/</ig) != null) {
			str=str.replace(/</ig,'&lt;');
			}
		while(str.match(/>/ig) != null) {
			str=str.replace(/>/ig,'&gt;');
			}
		while(str.match(/\'/ig) != null) {
			str=str.replace(/\'/ig,"&#39;");
		}
		while(str.match(/\"/ig) != null) {
			str=str.replace(/\"/ig,"&#34;");
		}
	}catch(e) {
	}
	return str;
}

function doEncode1Tagp(str) {
	try{
		while(str.match("&amp;amp;") != null) {
			str=str.replace("&amp;amp;",'&amp;');
			}
		while(str.match("&amp;lt;") != null) {
			str=str.replace("&amp;lt;",'<');
			}
		while(str.match("&amp;gt;") != null) {
			str=str.replace("&amp;gt;",'>');
			}
		while(str.match("\'") != null) {
			str=str.replace("\'","&#39;");
			}
		while(str.match("&amp;quot;") != null) {
			str=str.replace("&amp;quot;","&#34;");
		}
	}catch(e) {
	}
	return str;
}

var arrWord=new Array;
