// htmlArea v3.0 - Copyright (c) 2002-2004 interactivetools.com, inc.
// This copyright notice MUST stay intact for use (see license.txt).
//
// Portions (c) dynarch.com, 2003-2004
//
// A free WYSIWYG editor replacement for <textarea> fields.
// For full source code and docs, visit http://www.interactivetools.com/
//
// Version 3.0 developed by Mihai Bazon.
//   http://dynarch.com/mishoo
//
// Portions (c) Copyright 2004,2005 SWsoft, Inc. http://www.swsoft.com
//
/*
var clippboardval;
var mvContent;
var vFirst;
var vLast;
var vLength;
var vURL;
var elb
var els;
var elf;
var win=null;
var upload=false;
*/
HTMLArea.Config.prototype.registerButton = function(id, tooltip, image, textMode, prvMode, dsMode, action, context) {
	var the_id;
	if (typeof id == "string") {
		the_id = id;
	} else if (typeof id == "object") {
		the_id = id.id;
	} else {
		alert(fMessage("error") + " [HTMLArea.Config::registerButton]:\n" + fMessage("invalidarguments"));
		return false;
	}
	if (typeof this.customSelects[the_id] != "undefined") {
		alert(fMessage("warning") + " [HTMLArea.Config::registerDropdown]:\n" + fMessage("adropdownwith"));
	}
	if (typeof this.btnList[the_id] != "undefined") {
		alert(fMessage("warning") + " [HTMLArea.Config::registerDropdown]:\n"+ fMessage("adropdownwithexists"));
	}
	switch (typeof id) {
		case "string": this.btnList[id] = [ tooltip, image, textMode, prvMode, dsMode, action, context ]; break;
		case "object": this.btnList[id.id] = [ id.tooltip, id.image, id.textMode, id.prvMode, id.dsMode, id.action, id.context ]; break;
	}
};

HTMLArea.Config.prototype.registerDropdown = function(object) {
	if (typeof this.customSelects[object.id] != "undefined") {
		alert(fMessage("error") + " [HTMLArea.Config::registerDropdown]:\n" + fMessage("adropdownwith"));
	}
	if (typeof this.btnList[object.id] != "undefined") {
		alert(fMessage("error") + " [HTMLArea.Config::registerDropdown]:\n" + fMessage("adropdownwith"));
	}
	this.customSelects[object.id] = object;
};

var countNL=0;
var countDiv=0;

HTMLArea.prototype._createToolbar = function () {
	var editor = this;
	var toolbar = document.createElement("div");
	this._toolbar = toolbar;
	toolbar.className = "toolbar";
	toolbar.unselectable = "1";
	var tb_row = null;
	var tb_objects = new Object();
	this._toolbarObjects = tb_objects;
	function newLine() {
		var table = document.createElement("table");
		table.style.width="99%";
		table.id="toolbar"+countNL;
		table.border = "0px";
		table.cellSpacing = "0px";
		table.cellPadding = "0px";
		toolbar.appendChild(table);
		var tb_body = document.createElement("tbody");
		table.appendChild(tb_body);
		tb_row = document.createElement("tr");
		tb_body.appendChild(tb_row);
		var td_first=document.createElement("td");
		tb_row.appendChild(td_first);
		td_first.style.height="24px";
		td_first.style.width="5px";
		countNL++;
	};
	newLine();

	function setButtonStatus(id, newval) {
		var oldval = this[id];
		var el = this.element;
		if (oldval != newval) {
			switch (id) {
				case "enabled":
					if (newval) {
						HTMLArea._removeClass(el, "buttonDisabled");
						el.disabled = false;
					} else {
						HTMLArea._addClass(el, "buttonDisabled");
						el.disabled = true;
					}
					break;
				case "active":
					if (newval) {
						HTMLArea._addClass(el, "buttonPressed");
					} else {
						HTMLArea._removeClass(el, "buttonPressed");
					}
					break;
			}
			this[id] = newval;
		}
	}; 

	function createSelect(txt) {
		var options = null;
		var el = null;
		var cmd = null;
		var customSelects = editor.config.customSelects;
		var context = "style";
		switch (txt) {
			case "fontsize":
			case "fontname":
			case "formatblock":
				options = editor.config[txt];
				cmd = txt;
				break;
			default:
				cmd = txt;
				var dropdown = customSelects[cmd];
				if (typeof dropdown != "undefined") {
					options = dropdown.options;
					context = dropdown.context;
				} else {
					alert(fMessage("error") + " [createSelect]:\n" + fMessage("cantfinddefinition"));
				}
				break;
		}
		if (options) {
			el = document.createElement("select");
			if (txt=="fontsize") {
				el.style.width="70px";
			} else if (txt=="fontname") {
				el.style.width="120px";
			} else if (txt=="formatblock") {
				el.style.width="75px";
			}
			var obj = {
				name		: txt, // field name
				element : el,		// the UI element (SELECT)
				enabled : true, // is it enabled?
				text		: false, // enabled in text mode?
				prv		: false,
				ds		: true,
				cmd		: cmd, // command ID
				state		: setButtonStatus, // for changing state
				context : context
			};
			tb_objects[txt] = obj;
			for (var i in options) {
				var op = document.createElement("option");
				op.appendChild(document.createTextNode(i));
				op.value = options[i];
				el.appendChild(op);
			}
			el.size=1;
			el.multiple=false;
			HTMLArea._addEvent(el, "change", function () {
				editor._comboSelected(el, txt);
				}
			);
		}
		return el;
	};
	   
	function createButton(txt) {
		var el = null;
		var el1 = null;
		var btn = null;
		switch (txt) {
			case "sb_100":
				el = document.createElement("div");
				el.id="sb_100";
				break;
			 case "separator":
				el = document.createElement("div");
				el.id="divtoolbar"+countDiv;
				countDiv++;
				el.className = "separator";
				break;
			case "space":
				el = document.createElement("div");
				el.className = "space";
				break;
			case "linebreak":
				newLine();
				return false;
				case "linebreaknone":
				el = document.createElement("div");
				el.className = "space";
				break;
			case "textindicator":
				el = document.createElement("div");
				el.appendChild(document.createTextNode("A"));
				el.className = "indicator";
				el.title = fMessage("currentstyle");
				var obj = {
					name		: txt, // the button name (i.e. 'bold')
					element : el, // the UI element (DIV)
					enabled : true, // is it enabled?
					active : false, // is it pressed?
					text : false, // enabled in text mode?
					prv : false,
					ds : true,
					cmd : "textindicator", // the command ID
					state : setButtonStatus // for changing state
				};
				tb_objects[txt] = obj;
				break;
			default:
				btn = editor.config.btnList[txt];
		}
		if (!el && btn) {
			el = document.createElement("div");
			el.title = btn[0];
			el.className = "button";
			var obj
			obj = {
				name : txt, // the button name (i.e. 'bold')
				element : el, // the UI element (DIV)
				enabled : true, // is it enabled?
				active : false, // is it pressed?
				text : btn[2], // enabled in text mode?
				prv : btn[3],
				ds : btn[4],
				cmd : btn[5], // the command ID
				state : setButtonStatus, // for changing state
				context : btn[6] || null // enabled in a certain context?
			};
			if (txt=="fullscreen") {
				elf=el;
				if (editor.fullscreen==true) {
					HTMLArea._addClass(el, "buttonPressed");
					el.title = editor.mvNST;
				} else {
					HTMLArea._removeClass(el, "buttonPressed");
					el.title = editor.mvFST;
				}
			}
			if (txt=="save") {
				el.title = editor.mvSave;
			}
			if (txt=="spell") {
				editor.el_menu=el;
			}
			if (txt=="shbord") {
				elb=el;
				if (editor.showborders==true) {
					HTMLArea._addClass(el, "buttonPressed");
				} else {
					HTMLArea._removeClass(el, "buttonPressed");
				}
			}
			if (txt=="shscr") {
				els=el;
				if (editor.showscripts==true) {
					HTMLArea._addClass(el, "buttonPressed");
				} else {
					HTMLArea._removeClass(el, "buttonPressed");
				}
			}
			tb_objects[txt] = obj;
			HTMLArea._addEvent(el, "mouseover", function () {
				if (obj.enabled) {
					HTMLArea._addClass(el, "buttonHover");
				}
			});
			HTMLArea._addEvent(el, "mouseout", function () {
				if (obj.enabled) with (HTMLArea) {
					_removeClass(el, "buttonHover");
					_removeClass(el, "buttonActive");
					(obj.active) && _addClass(el, "buttonPressed");
				}
			});
			HTMLArea._addEvent(el, "mousedown", function (ev) {
				if (obj.enabled) with (HTMLArea) {
					_addClass(el, "buttonActive");
					_removeClass(el, "buttonPressed");
					_stopEvent(is_ie ? window.event : ev);
				}
			});
			HTMLArea._addEvent(el, "click", function (ev) {
				if (obj.enabled) with (HTMLArea) {
					_removeClass(el, "buttonActive");
					_removeClass(el, "buttonHover");
					obj.cmd(editor, obj.name, obj);
					_stopEvent(is_ie ? window.event : ev);
				}
			});
			var img = document.createElement("img");
			img.src = editor.imgURL(btn[1]);
			img.style.width = "18px";
			img.style.height = "18px";
			el.appendChild(img);
		} else if (!el) {
			el = createSelect(txt);
		}
		if (el) {
			var tb_cell = document.createElement("td");
			var test = "";
			try{
				test = el.id;
			}catch(e) {
			}
			if (test=="sb_100") {
				tb_cell.style.width="100%";
				tb_row.appendChild(tb_cell);
				tb_cell.appendChild(el);
			}else if (test=="sb_save_button") {
				tb_cell.style.width="100%";
				tb_cell.varticalAlign = "middle";
				tb_cell.textAlign = "right";
				var table1 = document.createElement("table");
				table1.align = "right";
				table1.border = "0px";
				table1.cellSpacing = "0px";
				table1.cellPadding = "0px";
				var tb_body1 = document.createElement("tbody");
				table1.appendChild(tb_body1);
				tb_row1 = document.createElement("tr");
				tb_body1.appendChild(tb_row1);
				var td_first1=document.createElement("td");
				tb_row1.appendChild(td_first1);
				td_first1.appendChild(el);
				td_first2=document.createElement("td");
				tb_row1.appendChild(td_first2);
				td_first2.appendChild(el1);
				tb_row.appendChild(tb_cell);
				tb_cell.appendChild(table1);
			} else {
				tb_row.appendChild(tb_cell);
				tb_cell.appendChild(el);
			}
		} else {
			alert(fMessage("fixme") + " " + fMessage("unknowntoolbaritem") + txt);
		}
		return el;
	};

	var first = true;
	for (var i in this.config.toolbar) {
		var group = this.config.toolbar[i];
		for (var j in group) {
			var code = group[j];
			if (/^([IT])\[(.*?)\]/.test(code)) {
				var l7ed = RegExp.$1 == "I";
				var label = RegExp.$2;
				if (l7ed) {
				}
				var tb_cell = document.createElement("td");
				tb_row.appendChild(tb_cell);
				tb_cell.className = "label";
				tb_cell.innerHTML = label;
			} else {
				createButton(code);
			}
		}
	}
	this._htmlArea.appendChild(toolbar);
};

HTMLArea.prototype._createStatusBar = function() {
	var div = document.createElement("div");
	div.className = "statusBar";
	div.innerHTML='<table border="0" width="100%" cellpadding="0" cellspacing="0"><tbody><tr><td style="padding-left:3px;" width="80%" name="SB_statTProp" id="SB_statTProp"></td><td width="20%" name="SB_statProp" id="SB_statProp"></td></tr></tbody></table>';
	this._htmlArea.appendChild(div);
	this._statusBar = div;
	this._statusBar.style.position="relative";
	this._statusBar.style.height="24px";
	var tp=document.getElementsByName("SB_statTProp").item(0);
	var tap=document.getElementsByName("SB_statProp").item(0);
	if (HTMLArea.is_ie) {
		this._statusBar.style.top=document.body.clientHeight-247+"px";
		//this._statusBar.style.top=document.body.clientHeight-204+"px";
	} else {
		this._statusBar.style.top=window.innerHeight-248+"px";
		//this._statusBar.style.top=window.innerHeight-205+"px";
	}
	div = document.createElement("span");
	div.className = "statusBarTree";
	this._statusBarTree = div;
	if (HTMLArea.is_ie) {
		this._statusBarTree.style.paddingTop="4px";
	} else {
		this._statusBarTree.style.paddingTop="4px";
	}
	this._statusBarTree.style.height="24px";
	tp.appendChild(div);
	var div1 = document.createElement("div");
	div1.style.height="24px";
	div1.style.width="100%";
	div1.style.Align="right"
	div1.innerHTML='<table border="0" align="right" cellpadding="0" cellspacing="0"><tbody><tr><td><table  id="SB_tag_prop" name="SB_tag_prop" border="0" align="right" cellpadding="0" cellspacing="0"><tbody><tr><td style="background-color: #ECE9D8;padding-left:5px;padding-right:5px;padding-top:1px;padding-bottom:1px;border-width:1px;border-top-width:0px;border-style:solid;border-color:#ACA899;font-size:9px;font-family:Tahoma,Verdana,sans-serif;color:#000000;cursor: pointer; cursor: hand;" onclick="editor.TagProperty();"><nobr>'+fMessage("properties")+'</nobr></td></tr></tbody></table></td><td>&#160;</td><td><table id="SB_tag_css" name="SB_tag_css" border="0" align="right" cellpadding="0" cellspacing="0"><tbody><tr><td style="background-color: #ECE9D8;padding-left:5px;padding-right:5px;padding-top:1px;padding-bottom:1px;border-width:1px;border-top-width:0px;border-style:solid;border-color:#ACA899;font-size:9px;font-family:Tahoma,Verdana,sans-serif;color:#000000;cursor: pointer; cursor: hand;"  onclick="editor.TagStl();"><nobr>'+fMessage("advanced")+'</nobr></td></tr></tbody></table></td><td style="font-size: 6px; width: 5px;">&#160;</td></tr></tbody></table>';
	this._statusBarBut=div1;
	tap.appendChild(div1);
	var temp=document.getElementsByName("SB_tag_prop").item(0);
	this._tag=temp;
	temp.style.display="none";
	temp=document.getElementsByName("SB_tag_css").item(0);
	this._css=temp;
	temp.style.display="none";
	if (!this.config.statusBar) {
		div.style.display = "none";
	}
};

var hg1;
var style;

HTMLArea.prototype.generate = function () {
	
	if (HTMLArea.is_ie) {
		this.generate_ie();
	} else {
		this.generate_other();
	}
	
/*	
	style=this.mvContAll.match(/<head>(.*?)<\/head>/gim);
	try{
		this.style=style[0].substr(6,style[0].length-13);
	}catch(e) {
		this.style="";
	}
	var editor = this;
	this._all=document.createElement("div");
	this._all.style.width = "100%";
	var textarea = this._textArea;
	if (typeof textarea == "string") {
		this._textArea = textarea = document.getElementById(textarea);
	}
	this._ta_size = {
		w: textarea.offsetWidth,
		h: textarea.offsetHeight
	};
	textarea.style.display = "none";
	var htmlarea = document.createElement("div");
	htmlarea.className = "htmlarea";
	this._htmlArea = htmlarea;
	textarea.parentNode.appendChild(this._all);
	this._all.appendChild(htmlarea);
	this._all.appendChild(textarea);
	this._menu=document.getElementsByName("SB_menu_div").item(0);
	if (textarea.form) {
		textarea.form.onsubmit = function() {
			editor._textArea.value = editor.getHTML();
		};
	}
	window.onunload = function() {
		editor._textArea.value = editor.getHTML();
	};
	this._createToolbar();
	var iframe= document.getElementById("IFR_0");
	iframe.style.display="";
	iframe.style.height="100%"
	iframe.style.width="100%"
	var divsb=document.createElement("div");
	this._divsb=divsb;
	divsb.style.dysplay="";
	divsb.style.position="absolute";
	htmlarea.appendChild(divsb);
	this._createStatusBar();
	divsb.innerHTML=fSetSB("");
	divsb.style.overflow="auto";
	var dab=document.getElementById("DIVSB_wb0");
	this._dab=dab;
	this._TD = document.getElementsByName("SB_stretch");
	dab.innerHTML="";
	dab.appendChild(iframe);
	this._iframe = iframe;
	this.SelNode =  null;
	iframe.scrolling="no";
	var tdtemp
	tdtemp=dab;
	if (!HTMLArea.is_ie) {
		iframe.style.borderWidth = "0";
	}
	if (HTMLArea.is_ie) {
		iframe.frameBorder = "0";
	}
	if (HTMLArea.is_ie) {
		height = parseInt(document.body.clientHeight)-2;
	} else {
		height = parseInt(window.innerHeight);
	}
	height = height-177;
	var width = (this.config.width == "auto" ? (this._ta_size.w + "px") : this.config.width);
	width = parseInt(width);
	if (!HTMLArea.is_ie) {
		height -= 2;
		width -= 2;
	}
	hg=this._toolbar.offsetHeight;
	editor.width="500px";
	if (HTMLArea.is_ie) {
		setWidth();
	}

	if (HTMLArea.is_ie) {
		iframe.style.width = editor.width;
	} else {
		iframe.style.width = "100%";
	}
	if (this.config.sizeIncludesToolbar) {
		var er=this._toolbar.offsetHeight/3;
		var er1;
		er1=height;
		er1 -= er;
	}
	if (height < 0) {
		height = 0;
	}
	iframe.style.height = '100%';
	editor._iframe.style.height = 400 + "px";
	divsb.style.height = height-47-22 + "px";
	//divsb.style.height = height-26 + "px";
	divsb.style.width = "100%";
	textarea.style.height="10px";
	textarea.style.width="10px";

	if (HTMLArea.is_ie) {
		this.coordinate_ie();
	} else {
		this.coordinate_other();
	}
	setTimeout(initIframe, 100);
	setTimeout(init,100);
	
	
	*/
};

this._divW=0;
this._divH=0;

var hg;
var doc;
var docp;
var iframep;
var mvMode;

HTMLArea.prototype.setMode = function(mode) {
	mvMode=mode;
	if (this._editMode=="wysiwyg") {
		mvContent=setBody(HTMLArea.getHTML(this._doc.body, false));
	}
	switch (mode) {
		case "html":
			this._textArea.value = this.getHTML();
			this._iframe.style.display = "none";
			this._textArea.style.display = "block";
			if (this.config.statusBar) {
				this._statusBar.style.display = "none";
			}
			break;
		case "wysiwyg":
			if (HTMLArea.is_gecko) {
				try{
				this._doc.designMode = "off";
				}catch(e) {
				}
			}
			this._doc.body.innerHTML = this.getHTML();
			this._iframe.style.display = "block";
			this._textArea.style.display = "none";
			if (HTMLArea.is_gecko) {
				try{
				   if (editor.mvPType=="HTML") {
						this._doc.designMode = "on";
					} else {
						this._doc.designMode = "off";
					}
				}catch(e) {
				}
			}
			if (HTMLArea.is_ie) {
				try{
					if (this.mvPType=="HTML") {
						this._doc.body.contentEditable = true;
					} else {
						this._doc.body.contentEditable = false;
					}
				}catch(e) {
				}
			}
			if (this.config.statusBar) {
					this._statusBar.style.display = "";
			}
			break;
		default:
			alert(fMessage("mode") + mode + fMessage("notdefined"));
			return false;
	}
	this._editMode = mode;
	this.focusEditor();
};

HTMLArea.prototype.InsSymbols = function() {
	var obj = new Object;
	obj.lang=Lang;
	obj.sp2 = sp2Detect(__trastedSite);
	this._popupDialog("special.html", function(symbol) {
		if (symbol) { 
			editor.insertHTML(symbol);
		}
	}, obj);
};

HTMLArea.prototype.registerPlugin = function(pluginName) {
	this.plugins[pluginName] = eval("new " + pluginName + "(this);");
};

HTMLArea.prototype.forceRedraw = function() {
	this._doc.body.style.visibility = "hidden";
	this._doc.body.style.visibility = "visible";
};

HTMLArea.prototype.focusEditor = function() {
	switch (this._editMode) {
		case "wysiwyg" :
			try{
				this._iframe.contentWindow.focus(); break;
			}catch(e) {
			}
		case "html": this._textArea.focus(); break;
		case "preview": this._iframe.contentWindow.focus(); break;
		default : alert(fMessage("mode") + this._editMode  + fMessage("notdefined"));
	}
	return this._doc;
};

var sb_chenge;
var sb_chenge_wizard;
HTMLArea.prototype._undoTakeSnapshot = function() {
	if (editor._editMode=="wysiwyg") {
		++this._undoPos;
		if (this._undoPos >= this.config.undoSteps) {
			this._undoQueue.shift();
			--this._undoPos;
		}
		var take = true;
		var txt = this.getInnerHTML();
		if (this._undoPos > 0)
			take = (this._undoQueue[this._undoPos - 1] != txt);
		if (take && this._applayUndo) {
			this._undoQueue[this._undoPos] = txt;
			if (this._undoQueue.length-1>this._undoPos) {
				var arrTemp = new Array();
				arrTemp = this._undoQueue;
				this._undoQueue = new Array();
				for(var i = 0; i < this._undoPos+1; i++) {
					this._undoQueue[i] = arrTemp[i];
				}
			}
		} else {
			this._undoPos--;
		}
	}
	if (HTMLArea.is_ie) {
		if (this._undoPos>1) {
			sb_chenge=document.getElementById("sb_changes");
			sb_chenge.value="1";
			sb_chenge_wizard=document.getElementById("sb_changes_wizard");
			sb_chenge_wizard.value="1";
		}
	} else {
		if (this._undoPos>1) {
			sb_chenge=document.getElementById("sb_changes");
			sb_chenge.value="1";
			sb_chenge_wizard=document.getElementById("sb_changes_wizard");
			sb_chenge_wizard.value="1";
		}
	}
	if (this._snap) {
		this._snap = false;
	} else {
		this._applayUndo = true;
	}
};

HTMLArea.prototype.undo = function() {
	this._snap=true;
	if (this._undoPos > 0) {
		var txt = this._undoQueue[--this._undoPos];
		if (txt) {
			this._applayUndo = false;
			this.setHTML(txt);
		}
		else ++this._undoPos;
	}
};

HTMLArea.prototype.redo = function() {
	this._snap=true;
	if (this._undoPos < this._undoQueue.length - 1) {
		var txt = this._undoQueue[++this._undoPos];
		if (txt) {
			this._applayUndo = false;
			this.setHTML(txt);
		}
		else --this._undoPos;
	}
};

HTMLArea.prototype.hideBut = function() {
	var des;
	if (mvMode=="wysiwyg") {
		des=true;
	} else {
		des==false;
	}
	for (var i in this._toolbarObjects) {
		var btn = this._toolbarObjects[i];
		if (!des && btn.name != "dsmode" && btn.name != "htmlmode" && btn.name != "prvmode" ) {
			btn.element.style.display = "none";
			var eltl=document.getElementById("toolbar1");
			eltl.style.display = "none";
			eltl=document.getElementById("toolbar2");
			eltl.style.display = "none";
			for(var f=1;f<countDiv;f++) {
				eltl=document.getElementById("divtoolbar"+f);
				eltl.className = "separator1";
			}
		} else {
			btn.element.style.display = "";
			var eltl=document.getElementById("toolbar1");
			eltl.style.display = "";
			eltl=document.getElementById("toolbar2");
			eltl.style.display = "";
			for(var f=1;f<countDiv;f++) {
					eltl=document.getElementById("divtoolbar"+f);
					eltl.className = "separator";
			}
		}
	}
};

HTMLArea.prototype.undoActive = function() {
	if (this._undoPos>1) {
		return true;
	} else {
		return false;
	}
}

HTMLArea.prototype.redoActive = function() {
	if ((this._undoQueue.length-1)>this._undoPos) {
		return true;
	} else {
		return false;
	}
}

HTMLArea.prototype.modActive = function(str) {
	var ancestors = this.getAllAncestors();
	var tp="none";
	try{
		tp=ancestors[0].type;
		if (ancestors[0].tagName.toLowerCase()=="img" && typeof tp == "undefined") {
			var txtTag=HTMLArea.getHTML(ancestors[0], true);
			if (/type=\"modules\"/.test(txtTag)) tp = "modules";
			if (/type=modules/.test(txtTag)) tp = "modules";
		}
	}catch(e) {
	}
	inContext =true;
	var el=this.getAllAncestors();
	if (/<td/i.test(this.getSelectedHTML())&&el[0].tagName.toLowerCase()!="table") {
		inContext =false;
	} else {
		inContext =true;
	}
	if (((tp=="modules" && ancestors[0].name==str) || tp!="modules") && inContext) {
		return true;
	} else {
		return false;
	}
}

this.key="0";

HTMLArea.prototype.clearTagIfImage = function() {
	if (!HTMLArea.is_ie) {
		try{
			var ch = this._doc.body.childNodes;
			for(var t = 0; t<ch.length; t++ ) {
				if (ch[t] == "[object HTMLTableElement]") {
					var p = this._doc.createElement("p");
					p.appendChild(ch[t].cloneNode(true));
					ch[t].parentNode.replaceChild(p,ch[t]);
				}
			}
		}catch(e) {
		}
	}
	if (this.drag && !HTMLArea.is_ie) {
		this.drag=false;
		var li = this.getParentElement();
		var img = li.firstChild;
		var ol = li.parentNode;
		var pn = ol.parentNode;
		while (pn.nodeType == 3) {
			pn = pn.parentNode;
		}
		if (li.tagName.toLowerCase()=="li") {
			if (li.firstChild.tagName.toLowerCase()=="img") {
				if ((ol.tagName.toLowerCase()=="ol" || ol.tagName.toLowerCase()=="ul") && ol.childNodes.length>1) {
				}else if (pn.tagName.toLowerCase()=="body") {
					var p=this._doc.createElement("p");
					p.appendChild(img);
					pn.replaceChild(p, ol);		
				} else {
					pn.replaceChild(img, ol);
				}
			}
		}
	}
	this._undoTakeSnapshot();
}

HTMLArea.prototype.getTagNameToEdit = function(tagName) {
	var result = false;
	for(var t=0; t<this.mvMASTAG.length; t++) {
		if (this.mvMASTAG[t].toLowerCase()==tagName) {
			result = true;
			break;
		}
	}
	return result;
}

var liSel=false;

HTMLArea.prototype.insertNodeAtSelection = function(toBeInserted, clear) {
	if (!HTMLArea.is_ie) {
		var sel = this._getSelection();
		var range = this._createRange(sel);
		var tt=false;
		var an = this.getAllAncestors();
		if (range.startContainer == "[object HTMLBodyElement]" && an[0].tagName.toLowerCase()=="body") {
			this._doc.body.innerHTML = "";
			var p = this._doc.createElement("p");
			p.innerHTML = "&#160;";
			this._doc.body.appendChild(p);
			this.selectNodeContents(p);
			sel = this._getSelection();
			range = this._createRange(sel);
		}
		if (range.startContainer=="[object Text]") {
			if (/<td>/i.test(this.getSelectedHTML())) tt=true;
		}
		sel.removeAllRanges();
		if (range.startContainer=="[object HTMLTableRowElement]" || range.startContainer=="[object HTMLTableSelectionElement]" || range.startContainer=="[object HTMLTableSectionElement]" || tt) {
			alert(fMessage("notallowedoperation"));
			return false;
		}
		if (range.startContainer=="[object HTMLTableCellElement]" && an[0].tagName.toLowerCase()!="img" && an[0].tagName.toLowerCase()!="hr") clear=false;
		
		if (clear) range.deleteContents();
		var node = range.startContainer;
		var pos = range.startOffset;		  
		switch (node.nodeType) {
			case 3: // Node.TEXT_NODE
				// we have to split it at the caret position.
				if (toBeInserted.nodeType == 3) {
					node.insertData(pos, toBeInserted.data);
					range = this._createRange();
					range.setEnd(node, pos + toBeInserted.length);
					range.setStart(node, pos + toBeInserted.length);
					sel.addRange(range);
				} else {
					node = node.splitText(pos);
					var selnode = toBeInserted;
					if (toBeInserted.nodeType == 11 /* Node.DOCUMENT_FRAGMENT_NODE */) {
						selnode = selnode.firstChild;
					}
					node.parentNode.insertBefore(toBeInserted, node);
					this.selectNodeContents(selnode);
					this.updateToolbar();
				}
				break;
			case 1: // Node.ELEMENT_NODE
				var selnode = toBeInserted;			 
				if (toBeInserted.nodeType == 11 /* Node.DOCUMENT_FRAGMENT_NODE */) {
					selnode = selnode.firstChild;
				}
				if (node == "[object HTMLTableElement]" || node == "[object HTMLImageElement]" || an[0].tagName.toLowerCase()=="a" || an[0].tagName.toLowerCase()=="br" || an[0].tagName.toLowerCase()=="ol" || an[0].tagName.toLowerCase()=="ul") {
					node.parentNode.replaceChild(toBeInserted, node);
				} else {
					node.insertBefore(toBeInserted, node.childNodes[pos]);
				}
				this.selectNodeContents(selnode);
				this.updateToolbar();
				break;
		}
	} else {
		var sel = this._getSelection();
		var an = this.getAllAncestors();
		if (sel.type.toLowerCase()=="control") {
			var range = this._createRange(sel);
			if (range.length>0) {
				var div = this._doc.createElement("div");
				div.id='inserInSel';
				range.item(0).replaceNode(div);
			}
		} else {
			var range = this._createRange(sel);
			var div1 = this._doc.createElement("span");
				div1.id='inserInSel';
			if (/<td>/i.test(range.htmlText)) {
				alert(fMessage("notallowedoperation"));
				return false;
			}
			try{
				var tag = this.SelNode;
			}catch(e) {
				var tag = an[0]
			}
			if (tag.tagName.toLowerCase()=="ol"||tag.tagName.toLowerCase()=="ul") {
				tag.parentNode.replaceChild(div1, tag);
			} else {
				range.pasteHTML("<span id='inserInSel'></span>");
			}
		}
		var div=this._doc.getElementById('inserInSel');
		if (toBeInserted.tagName.toLowerCase()=="img") {
			div.outerHTML = toBeInserted.outerHTML;
		} else {
			div.replaceNode(toBeInserted);
			this.selectNodeContents(toBeInserted);
		}
		this.updateToolbar();
	}
};

HTMLArea.prototype.getParentElement = function() {
	var sel = this._getSelection();
	var range = this._createRange(sel);
	if (HTMLArea.is_ie) {
		switch (sel.type) {
			case "Text":
			case "None":
				return range.parentElement();
			case "Control":
				return range.item(0);
			default:
				return this._doc.body;
		}
	} else try {
		var p = range.commonAncestorContainer;
		var tt = false;
		try{
			if (range.startContainer.childNodes[range.startOffset]=="[object HTMLImageElement]" || range.startContainer.childNodes[range.startOffset]=="[object HTMLHRElement]" || range.startContainer.childNodes[range.startOffset]=="[object HTMLTableElement]") tt=true;
		}catch(e) {
		}
		if (!range.collapsed && range.startContainer == range.endContainer &&
			range.startOffset - range.endOffset <= 1 && range.startContainer.hasChildNodes()&&tt)
			p = range.startContainer.childNodes[range.startOffset];
			/*
			alert(range.startContainer + ":" + range.startOffset + "\n" +
				  range.endContainer + ":" + range.endOffset);
			*/
		while (p.nodeType == 3) {
			p = p.parentNode;
		}
		return p;
	} catch (e) {
		return null;
	}
};

HTMLArea.prototype.getAllAncestors = function() {
	var p = this.getParentElement();
	var a = [];
	try{
		while (p && (p.nodeType == 1) && (p.tagName.toLowerCase() != 'body')) {
			if (p.tagName.toLowerCase() != 'html') {
				a.push(p);
			}
			p = p.parentNode;
		}
		a.push(this._doc.body);
	}catch(e) {
	}
	return a;
};

HTMLArea.prototype.getAllAncestorsMod = function(node) {
	var p = node;
	var a = [];
	try{
		while (p && (p.nodeType == 1) && (p.tagName.toLowerCase() != 'body')) {
			if (p.tagName.toLowerCase() != 'html') {
				a.push(p);
			}
			p = p.parentNode;
		}
		a.push(this._doc.body);
	}catch(e) {
	}
	return a;
};

HTMLArea.prototype.selectNodeContents1 = function(node, pos) {
	this.SelNode=node;
	SNTest=true;
	this.focusEditor();
	this.forceRedraw();
	var sel = this._getSelection();
	var range;
	var collapsed = (typeof pos != "undefined");
	
	if (HTMLArea.is_ie) {
		try{				
			range = this._doc.body.createTextRange();
			range.moveToElementText(node);
			(collapsed) && range.collapse(pos);
			range.select();				 
		}catch(e) {
		}
	} else {
		range = this._doc.createRange(sel);
		var et = "none";
		try{
			et = node.tagName.toLowerCase();
		}catch(e) {
		}
		if (node=="[object HTMLHRElement]" || node=="[object HTMLTableElement]" || et=="a" || et=="div") {
				range.selectNode(node);
		} else {
			range.selectNodeContents(node);
		}
		(collapsed) && range.collapse(pos);
		sel.removeAllRanges();
		sel.addRange(range);
	}
};

HTMLArea.prototype.selectNodeContents = function(node, pos) {
	this.SelNode=node;
	SNTest=true;
	this.focusEditor();
	this.forceRedraw();
	var sel = this._getSelection();
	var range;
	var collapsed = (typeof pos != "undefined");
	
	if (HTMLArea.is_ie) {
		try{
			if (node.tagName.toLowerCase()=="table" || node.tagName.toLowerCase()=="img") {
				range = this._doc.body.createControlRange();
				range.addElement(node);
				range.select();
			} else {
				range = this._doc.body.createTextRange();
				range.moveToElementText(node);
				(collapsed) && range.collapse(pos);
				range.select();
			}
		}catch(e) {
		}
	} else {
		range = this._doc.createRange(sel);
		var et = "none";
		try{
			et = node.tagName.toLowerCase();
		}catch(e) {
		}
		if (node=="[object HTMLHRElement]" || node=="[object HTMLTableElement]" || et=="a" || et=="div") {
			range.selectNode(node);
		} else {
			range.selectNodeContents(node);
		}
		(collapsed) && range.collapse(pos);
		sel.removeAllRanges();
		sel.addRange(range);
	}
};

HTMLArea.prototype.insertHTML = function(html) {
	var sel = this._getSelection();
	var range = this._createRange(sel);
	if (HTMLArea.is_ie) {
		this.focusEditor();
		sel = this._iframe.contentWindow.document.selection;
		if (sel.type.toLowerCase()=="control") {
			var range = this._createRange(sel);
			if (range.length>0) {
					range.item(0).outerHTML=html;
			}
		} else {
			var range = this._createRange(sel);
			range.pasteHTML(html);
		}							
	} else {
		var fragment = this._doc.createDocumentFragment();
		var div = this._doc.createElement("div");
		div.innerHTML = html;
		while (div.firstChild) {
			fragment.appendChild(div.firstChild);
		}
		var node = this.insertNodeAtSelection(fragment, true);
	}
//	this.editableContentResize(); 
};

HTMLArea.prototype.surroundHTML = function(startTag, endTag) {
	var html = this.getSelectedHTML();
	this.insertHTML(startTag + html + endTag);
};

HTMLArea.prototype.getSelectedHTML = function() {
	var sel = this._getSelection();
	var range = this._createRange(sel);
	var existing = null;
	if (HTMLArea.is_ie) {
		if (sel.type=="Control") {
			existing=range.item(0).outerHTML;
		} else {
			existing = range.htmlText;
		}
	} else {
		try{
			existing = HTMLArea.getHTML(range.cloneContents(), false);
		}catch(e) {
		}
	}
	return existing;
};

HTMLArea.prototype.getSelectedHTMLCol = function() {
	var sel = this._getSelection();
	var range = this._createRange(sel);
	var existing = null;
	if (HTMLArea.is_ie) {
		existing = range.htmlText;
	} else {
		try{
			existing = HTMLArea.getHTML(range.commonAncestorContainer, true);
		}catch(e) {
		}
	}
	return existing;
};

HTMLArea.prototype._insertImage = function() {
	this._undoTakeSnapshot();
	var path=HTMLArea.HERE;
	var obj=new Object;
	obj.sp2=sp2Detect(__trastedSite);
	obj.imga=this.config.editorURL+"/wysiwyg/images/arrow.gif";
	obj.lang=Lang;
	obj.url=this.url;
	obj.BASEURL=this.URLBASE;
	var path=path.substr(0,path.length-8);
	var editor = this;
	obj.path=path+this.popupURL("navigator.html");
	obj.url='';
	obj.alt='';
	obj.border='';
	obj.align='';
	obj.vert='0';
	obj.horiz='0';
	obj.sn='false';
	obj.el=null;
	try{
		if (this.SelNode.tagName.toLowerCase()=='img') {
			var type="none";
			try{
				type=this.SelNode.type;
				if (this.SelNode.tagName.toLowerCase()=="img" && typeof type == "undefined") {
					var txtTag=HTMLArea.getHTML(this.SelNode, true);
					if (/type=\"modules\"/.test(txtTag)) type = "modules";
				}
			}catch(e) {	
			}
			if (type=="modules") {
				alert(fMessage("notallowedoperation"));
				return false;
			}
			obj.url=this.SelNode.src;
			obj.alt=this.SelNode.alt;
			obj.border = parseInt(this.SelNode.style.borderWidth);
			isNaN(obj.border) && (obj.border = "");
			obj.align=this.SelNode.align;
			obj.align = obj.align.toLowerCase();
			obj.vert=parseInt(this.SelNode.vspace);
			isNaN(obj.vert) && (obj.vert = "0");
			obj.horiz=parseInt(this.SelNode.hspace);
			isNaN(obj.horiz) && (obj.horiz = "0");
			obj.sn='true';
			obj.el=this.SelNode;
		}
	}catch(e) {
	}

	this._popupDialog("insert_image.html", function(param) {
		if (!param) {
			return false;
		}
		if (param["sn"]=='true') {
			for (field in param) {
			var value = param[field];
			if (!value) {
				continue;
			}
			switch (field) {
				case "f_url" :
					try{
						param["el"].src = value;
					}catch(e) {
					}
					break;
				case "f_alt" :
					try{
						param["el"].alt = value;
					}catch(e) {
					}
					break;
				case "f_border" :
					try{
						param["el"].style.borderWidth = parseInt(value);
					}catch(e) {
					}
					break;
				case "f_align"  :
					try{
						param["el"].align = value;
					}catch(e) {
					}
					break;
				case "f_vert"   :
					try{
						param["el"].vspace = parseInt(value);
					}catch(e) {
					}
					break;
				case "f_horiz"  :
					try{
						param["el"].hspace = parseInt(value);
					}catch(e) {
					}
					break;
				}
			}
		} else {
			var div = document.createElement("div");
			if (HTMLArea.is_ie) {
				str = "<img src='"+param["f_url"]+"' height='"+param["height"]+"' width='"+param["width"]+"' hspace='"+param["f_horiz"]+"' vspace='"+param["f_vert"]+"' align='"+param["f_align"]+"' alt='"+doEncode1Tagp(param["f_alt"])+"' border='0' style='border-style: solid; border-color: #000000; border-width: "+param["f_border"]+";'/>";
			} else {
				str = "<img src='"+param["f_url"]+"' height='"+param["height"]+"' width='"+param["width"]+"' hspace='"+param["f_horiz"]+"' vspace='"+param["f_vert"]+"' align='"+param["f_align"]+"' alt='"+doEncode1Tagp(param["f_alt"])+"' border='0' style='border-style: solid; border-color: #000000; border-width: "+param["f_border"]+";'/>";
			}
			div.innerHTML = str;
			editor.insertNodeAtSelection(div.childNodes[0], true);
		}
		 editor._undoTakeSnapshot();
	 	editor.editableContentResize();
		return true;
	}, obj);	
};

HTMLArea.prototype.setCursorAtNode = function(el) {
	var eln = null;
	var elp = null;
	try{
		eln = el.nextSibling;
		elp = el.previousSibling;
		if (eln && eln!=null) {
			this.setCursorAtChar(eln);
		}else if (elp && elp!=null) {
			this.setCursorAtChar(elp);
		}
	}catch(e) {
	}
}

HTMLArea.prototype.setCursorAtChar = function(el) {
	this.selectNodeContents(el);
	var sel = this._getSelection();
	if (HTMLArea.is_ie) {
		var range = this._createRange(sel);
		range.move("character");
		range.move("character",-1);
		range.select();
	} else {
		var range = this._createRange();
		range.setStart(el,0);
		range.setEnd(el,0); 
		sel.removeAllRanges();
		sel.addRange(range);
	}
}

HTMLArea.prototype._insertTable = function(dbl) {
	this._undoTakeSnapshot();
	var sel = this._getSelection();
	var range = this._createRange(sel);
	var editor = this;
	var objt = new Object();
	objt.imga=this.config.editorURL+"/wysiwyg/images/arrow.gif";
	try{
		if (this.SelNode.tagName.toLowerCase()=="img") {
			alert(fMessage("notallowedoperation"));
			return false;
		}
	}catch(e) {
	}
	objt.sp2=sp2Detect(__trastedSite);
	objt.lang=Lang;
	objt.cellspacing ="0";
	objt.cellpadding = "0";
	objt.border = "0";
	objt.align = "";
	objt.rows = "";
	objt.cells = "";
	objt.width = "";
	objt.unit="";
	objt.sn="false";
	objt.el=null;
	try{
		var tag=this.getAllAncestors();
		if (tag[0].tagName.toLowerCase()=="table") this.SelNode=tag[0];
		if (tag[0].tagName.toLowerCase()=="tbody") this.SelNode=tag[1];
		if (tag[0].tagName.toLowerCase()=="tr" && tag[1].tagName.toLowerCase()=="tbody") this.SelNode=tag[2];
		if (tag[0].tagName.toLowerCase()=="tr" && tag[1].tagName.toLowerCase()=="table") this.SelNode=tag[1];
		if (dbl) {
			if (tag[0].tagName.toLowerCase()=="td" && tag[2].tagName.toLowerCase()=="tbody") this.SelNode=tag[3];
			if (tag[0].tagName.toLowerCase()=="td" && tag[2].tagName.toLowerCase()=="table") this.SelNode=tag[2];
		} else {
			if (tag[0].tagName.toLowerCase()=="td") this.SelNode=tag[0];
		}
		if (this.SelNode.tagName.toLowerCase()=='table') {
			objt.cellspacing = parseInt(this.SelNode.cellSpacing);
			isNaN(objt.cellspacing) && (objt.cellspacing = "0");
			objt.cellpadding = parseInt(this.SelNode.cellPadding);
			isNaN(objt.cellpadding) && (objt.cellpadding = "0");
			objt.border = parseInt(this.SelNode.border);
			isNaN(objt.border) && (objt.border = "0");
			objt.align = this.SelNode.align.toLowerCase();
			objt.rows = this.SelNode.rows.length;
			objt.sn="true";
			objt.el=this.SelNode;
			objt.cells = this.SelNode.rows[0].cells.length;
			objt.width = parseInt(this.SelNode.style.width);
			isNaN(objt.width) && (objt.width = "");
			if (/%/.test(this.SelNode.style.width)) {
				objt.unit="%";
			}else if (/px/.test(this.SelNode.style.width)) {
				objt.unit="px";
			}else if (/pt/.test(this.SelNode.style.width)) {
				objt.unit="pt";
			} else {
				objt.unit="";
			}
		}
	}catch(e) {
	}

	this._popupDialog("insert_table.html", function(param) {
		if (!param) {
			return false;
		}
		if (param["sn"]=='true') {
			for (var field in param) {
			var value = param[field];
				if (!value) {
					continue;
				}
				switch (field) {
					case "f_width"   : param["el"].style.width = value + param["f_unit"]; break;
					case "f_align"   : param["el"].align		 = value; break;
					case "f_border"  : param["el"].border		 = parseInt(value); break;
					case "f_spacing" : param["el"].cellSpacing = parseInt(value); break;
					case "f_padding" : param["el"].cellPadding = parseInt(value); break;
				}
			}
		} else {
			var doc3 = editor._doc;
			var table = doc3.createElement("table");
			for (var field in param) {
				var value = param[field];
				if (!value) {
					continue;
				}
				switch (field) {
					case "f_width"   : table.style.width = value + param["f_unit"]; break;
					case "f_align"   : table.align		 = value; break;
					case "f_border"  : table.border		 = parseInt(value); break;
					case "f_spacing" : table.cellSpacing = parseInt(value); break;
					case "f_padding" : table.cellPadding = parseInt(value); break;
				}
			}
			var tbody = doc3.createElement("tbody");
			if (!HTMLArea.is_ie) {
				table.appendChild(doc3.createTextNode(" "));
			}
			table.appendChild(tbody);
			if (!HTMLArea.is_ie) {
				table.appendChild(doc3.createTextNode(" "));
			}
			for (var i = 0; i < param["f_rows"]; ++i) {
				var tr = doc3.createElement("tr");
				tbody.appendChild(tr);
				for (var j = 0; j < param["f_cols"]; ++j) {
					var td = doc3.createElement("td");
					tr.appendChild(td);
					td.innerHTML = "&#160;"
				}
			}
			editor.insertNodeAtSelection(table, true);
			try{
				editor.selectNodeContents(table.rows[0].cells[0]);
			}catch(e) {
			}
		}
		editor._undoTakeSnapshot();
		editor.editableContentResize();
		return true;
	}, objt);
};

HTMLArea.prototype._comboSelected = function(el, txt) {
	this.focusEditor();
	var value = el.options[el.selectedIndex].value;
	switch (txt) {
		case "fontname": this.execCommand(txt, false, value);break;
		case "fontsize": this.execCommand(txt, false, value); break;
		case "formatblock":
			(HTMLArea.is_ie) && (value = "<" + value + ">");
			this.execCommand(txt, false, value);
			break;
		default:
			var dropdown = this.config.customSelects[txt];
			if (typeof dropdown != "undefined") {
				dropdown.action(this);
			} else {
				alert(fMessage("dsmode")+fMessage("combobox") + txt + fMessage("notimplemented"));
			}
	}
};

HTMLArea.prototype._verify = function(tagname) {
	switch(tagname.tagName.toLowerCase())
	{
		case "body":
		case "div":
		case "h1":
		case "h2":
		case "h3":
		case "h4":
		case "h5":
		case "h6":
		case "td":
		case "table":
		case "p":
		case "caption":
		case "ol":
		case "ul":
		case "li":
		case "pre":
		case "address":
			return true;
			break;
		case "span":
			if (tagname.parentNode.tagName.toLowerCase()=="body") {
				return true;
			} else {
				return false;
			}
			break;
		default:
			return false;
	}
};

HTMLArea.prototype.fAlign = function(param) {
	var tag=this.getAllAncestors();
	
	try{
		var slN=this.SelNode.tagName.toLowerCase();
	}catch(e) {
		var slN="none";
	}
	
	var breakFlag = true;
	if (tag[0].tagName.toLowerCase()=="body"||slN=="body") {
		breakFlag = false;
		tag = this.getTagInSelection();
	}
	for(var i=0; i<tag.length; i++) {
		if (this._verify(tag[i])) {
			if (tag[i].tagName.toLowerCase()=="body") {
				break;
				return false
			}
			if (tag[0].tagName.toLowerCase()=="tbody")
			{
				tag[1].style.textAlign=param;
				this.clearAlign(tag[0]);
				break;
				return false
			}
			if (param=="justify" && HTMLArea.is_ie) {
			} else {
				if (tag[0].tagName.toLowerCase()!="tr"&&tag[0].tagName.toLowerCase()!="tbody") {
					tag[i].align=param;
				}
			}
			if (tag[0].tagName.toLowerCase()!="table") {
				tag[i].style.textAlign=param;
				if (tag[i].tagName.toLowerCase()=="table") {
					this.clearAlign(tag[i-1]);
				}
				if (slN=="ol"||slN=="ul") {
					this.clearAlignList(this.SelNode,param);
				}
				if (tag[i].tagName.toLowerCase()=="ol"||tag[i].tagName.toLowerCase()=="ul") {
					this.clearAlignList(tag[i],param);
				}
			}
			if (breakFlag) break;
		}
	}
	return true;
};

HTMLArea.prototype._bold_dop = function(cmdID, UI, param) {
	var tag=this.getAllAncestors();
	if (!HTMLArea.is_ie) {
		this.CheckWordSelection();
	}
	this._doc.execCommand(cmdID, UI, param);
};

HTMLArea.prototype._bold = function(cmdID, UI, param) {
	var tag=this.getAllAncestors();
	var t1 = this.getSelectedHTML();
	switch(tag[0].tagName.toLowerCase())
	{
		case "li":
			if ( (t1.match(/<ol(.*?)>/gim,"") && t1.match(/<\/ol>/gim,"")) || (t1.match(/<ul(.*?)>/gim,"") && t1.match(/<\/ul>/gim,"")) ) {
				var ol_ul=tag[1].childNodes;
				if (tag[1].style.fontWeight!= "")
					tag[1].style.fontWeight = "";
				else
					tag[1].style.fontWeight = "bold";
				for(var i=0; i<ol_ul.length; i++) {
					if (ol_ul[i].style.fontWeight!="")
						ol_ul[i].style.fontWeight="";
					if (ol_ul[i].innerHTML.match(/<b>/gim,"") && ol_ul[i].innerHTML.match(/<\/b>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<b>/gim,"");
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/b>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<b>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<b>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<\/b>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/b>/gim,"");
					}
					if (ol_ul[i].innerHTML.match(/<strong>/gim,"") && ol_ul[i].innerHTML.match(/<\/strong>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<strong>/gim,"");
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/strong>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<strong>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<strong>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<\/b>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/strong>/gim,"");
					}
				}
				this.selectNodeContents(tag[1]);
				break;
			} 
			if (!(t1.match(/<li(.*?)>/gim,"") && t1.match(/<\/li>/gim,""))) {
				this._bold_dop(cmdID, UI, param);
				break;
			}
			if (tag[0].innerHTML.match(/<b>/gim,"") && tag[0].innerHTML.match(/<\/b>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<b>/gim,"");
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/b>/gim,"");
			}else if (tag[0].innerHTML.match(/<b>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<b>/gim,"");
			}else if (tag[0].innerHTML.match(/<\/b>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/b>/gim,"");
			}
			if (tag[0].innerHTML.match(/<strong>/gim,"") && tag[0].innerHTML.match(/<\/strong>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<strong>/gim,"");
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/strong>/gim,"");
			}else if (tag[0].innerHTML.match(/<strong>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<strong>/gim,"");
			}else if (tag[0].innerHTML.match(/<\/strong>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/strong>/gim,"");
			}
			if (tag[0].style.fontWeight != "") {
				tag[0].style.fontWeight = "";
			} else {
				tag[0].style.fontWeight = "bold";
			}
			this.selectNodeContents(tag[0]);
			break;
		default:
			this._bold_dop(cmdID, UI, param);
	}
};

HTMLArea.prototype._fontname = function(cmdID, UI, param) {
	var tag=this.getAllAncestors();
	var t1 = this.getSelectedHTML();
	var t2 = tag[0].innerHTML;
	if (tag[0].tagName.toLowerCase()=='hr') {
		alert(fMessage("notallowedoperation"));
		return false;
	}
	if (HTMLArea.is_ie) {
	   switch(tag[0].tagName.toLowerCase())
	   {
			case "li":
				 if ( t1.match(/<ol(.*?)>/gim,"")  || t1.match(/<ul(.*?)>/gim,"") ) {
					  var ol_ul=tag[1].childNodes;
					  for(var i=0; i<ol_ul.length; i++) {
						  ol_ul[i].style.fontFamily=param;
						  this.font_family_size_block(cmdID, UI, param, "family");
					  }
					  this.selectNodeContents(tag[1]);
					  break;
				  }
				  if (t1.match(/<li(.*?)>/gim,"") && t1.match(/<\/li>/gim,""))
					   tag[0].style.fontFamily=param;

				  this.font_family_size_block(cmdID, UI, param, "family");
				  break;
			default:
				 this.font_family_size_block(cmdID, UI, param, "family");
		}
	}
	else{
		if (t1.match(/<li(.*?)>/gim,"")) {
			var ol_ul=tag[0].childNodes;
			for(var i=0; i<ol_ul.length; i++) {
				 try{
					ol_ul[i].style.fontFamily=param;
					this.font_family_size_block(cmdID, UI, param, "family");
				 }catch(e) {
				 }
			}
			this.selectNodeContents(tag[0]);
		}else if (t1==t2 && (tag[1].tagName.toLowerCase()=="ol" || tag[1].tagName.toLowerCase()=="ul") ) {
			tag[0].style.fontFamily=param;
		}
		this.font_family_size_block(cmdID, UI, param, "family");
	}
};

HTMLArea.prototype.font_family_size_block = function(cmdID, UI, param, name) {
	var ft1=this._doc.getElementsByTagName("font");
	for(var r=0;r<ft1.length;r++) {
		switch(name)
		{
			case "family":
				if (HTMLArea.is_ie) ft1[r].style.removeAttribute("fontFamily");
				break;
			case "size":
				if (HTMLArea.is_ie) 
					ft1[r].style.removeAttribute("fontSize");
				else
					ft1[r].style.fontSize="";
				break;
		}
	}
	this._doc.execCommand(cmdID, UI, param);
	var ft=this._doc.getElementsByTagName("font");
	for(var r=0;r<ft.length;r++) {
		switch(name)
		{
			case "family":
				if (ft[r].face=="") {
					if (HTMLArea.is_ie) {
						ft[r].face=ft[r].style.fontFamily;
					}
				} else {
					ft[r].style.fontFamily=ft[r].face;
				}
				if (!HTMLArea.is_ie && (ft[r].face == "undefined" || ft[r].face == "")) {
					var ftt=ft[r].parentNode;
					if (ftt.style.fontFamily != "undefined" || ftt.style.fontFamily != "") {
						if (HTMLArea.is_ie) {
							ft[r].style.fontFamily = ftt.style.fontFamily;
							ft[r].face = ftt.style.fontFamily;
						}
					}
				}
				break;
			case "size":
				 ft[r].style.fontSize=setPT(ft[r].size);
				 break;
		}
	}
};

HTMLArea.prototype._fontsize = function(cmdID, UI, param) {
	var tag=this.getAllAncestors();
	var t1 = this.getSelectedHTML();
	var t2 = tag[0].innerHTML;
	if (tag[0].tagName.toLowerCase()=='hr') {
		alert(fMessage("notallowedoperation"));
		return false;
	}
	if (HTMLArea.is_ie) {
	   switch(tag[0].tagName.toLowerCase())
	   {
			case "li":
				if ( (t1.match(/<ol(.*?)>/gim,"") && t1.match(/<\/ol>/gim,"")) || (t1.match(/<ul(.*?)>/gim,"") && t1.match(/<\/ul>/gim,"")) ) {
					var ol_ul=tag[1].childNodes;
						for(var i=0; i<ol_ul.length; i++) {
							ol_ul[i].style.fontSize=setPT(param);
							this.font_family_size_block(cmdID, UI, param, "size");
						}
						this.selectNodeContents(tag[1]);
						 break;
					}
					if (t1.match(/<li(.*?)>/gim,"") && t1.match(/<\/li>/gim,""))
					tag[0].style.fontSize=setPT(param);
					this.font_family_size_block(cmdID, UI, param, "size");
					break;
			 default:
					this.font_family_size_block(cmdID, UI, param, "size");
		}
	}
	else{
		if (t1.match(/<li(.*?)>/gim,"")) {
			var ol_ul=tag[0].childNodes;
			for(var i=0; i<ol_ul.length; i++) {
				try{
					ol_ul[i].style.fontSize=setPT(param);
					this.font_family_size_block(cmdID, UI, param, "size");
				}catch(e) {
				}
			}
			this.selectNodeContents(tag[0]);
		}else if (t1==t2 && (tag[1].tagName.toLowerCase()=="ol" || tag[1].tagName.toLowerCase()=="ul") ) {
			tag[0].style.fontSize=setPT(param);
		}
		this.font_family_size_block(cmdID, UI, param, "size");
	}
};

HTMLArea.prototype._italic = function(cmdID, UI, param) {
	var tag=this.getAllAncestors();
	var t1 = this.getSelectedHTML();
	switch(tag[0].tagName.toLowerCase())
	{
		case "li":
			if ( (t1.match(/<ol(.*?)>/gim,"") && t1.match(/<\/ol>/gim,"")) || (t1.match(/<ul(.*?)>/gim,"") && t1.match(/<\/ul>/gim,"")) ) {
				var ol_ul=tag[1].childNodes;
				if (tag[1].style.fontStyle!= "")
					tag[1].style.fontStyle = "";
				else
					tag[1].style.fontStyle = "italic";
				for(var i=0; i<ol_ul.length; i++) {
					if (ol_ul[i].style.fontStyle!="")
						ol_ul[i].style.fontStyle="";
					if (ol_ul[i].innerHTML.match(/<em>/gim,"") && ol_ul[i].innerHTML.match(/<\/em>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<em>/gim,"");
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/em>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<em>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<em>/gim,"");
					}else if (ol_ul[i].innerHTML.match(/<\/em>/gim,"")) {
						ol_ul[i].innerHTML = ol_ul[i].innerHTML.replace(/<\/em>/gim,"");
					}
				}
				this.selectNodeContents(tag[1]);
				break;
			}
			if (!(t1.match(/<li(.*?)>/gim,"") && t1.match(/<\/li>/gim,""))) {
				this._doc.execCommand(cmdID, UI, param);
				break;
			}
			if (tag[0].innerHTML.match(/<em>/gim,"") && tag[0].innerHTML.match(/<\/em>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<em>/gim,"");
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/em>/gim,"");
			}else if (tag[0].innerHTML.match(/<em>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<em>/gim,"");
			}else if (tag[0].innerHTML.match(/<\/em>/gim,"")) {
				tag[0].innerHTML = tag[0].innerHTML.replace(/<\/em>/gim,"");
			}
			if (tag[0].style.fontStyle != "") {
				tag[0].style.fontStyle = "";
			} else {
				tag[0].style.fontStyle = "italic";
			}
			this.selectNodeContents(tag[0]);
			break;
		default:
			this._doc.execCommand(cmdID, UI, param);
	}
};

HTMLArea.prototype.checkSelection = function() {
	var div = document.createElement("div");
	div.innerHTML = this.getSelectedHTMLCol();
	var j=0;
	for(var i=0; i<div.childNodes.length; i++) {
		try{
			if (div.childNodes[i].nodeType==1) j++;
		}catch(e) {
		}
	}
	var ancestors = this.getAllAncestors();
	if (ancestors[0].tagName.toLowerCase()=="hr") j=0;
	if (ancestors[0].tagName.toLowerCase()=="tr") {
		var t = ancestors[0].innerHTML;
		var t1 = this.getSelectedHTML();
		while(/&nbsp;/.test(t)) {
		   t=t.replace("&nbsp;"," ");
		}
		while(/&nbsp;/.test(t1)) {
		   t1=t1.replace("&nbsp;"," ");
		}
		t1=escape(t1);
		t=escape(t);
		while(/%0D%0A/.test(t)) {
		   t=t.replace("%0D%0A","");
		}
		while(/C2%A0/.test(t1)) {
		   t1=t1.replace("C2%A0","20");
		}
		while(/%0D%0A/.test(t1)) {
		   t1=t1.replace("%0D%0A","");
		}
		if (t.toLowerCase()!=t1.toLowerCase()) {
			j=5;
		} else {
			j=0;
		}
	}
	if (j>1) {
		return true;
	} else {
		return false;
	}
}

HTMLArea.prototype.checkSelectionCol = function() {
	var div = document.createElement("div");
	var sel = this._getSelection();
	var range = this._createRange(sel);
	var obj = new Object();
	obj.tag="";
	if (HTMLArea.is_ie) {
		if (range.htmlText=="") {
			var pt = this.getParentElement();
			obj.tag=pt.tagName.toLowerCase();
			obj.count=1;
			return obj;
		}
		if (/<td>/i.test(range.htmlText)) {
			obj.tag="table";
			obj.count=1;
			return obj;
		}
	} else {
		if (range.toString()=="") {
			var pt = this.getParentElement();
			obj.tag=pt.tagName.toLowerCase();
			obj.count=1;
			return obj;
		}
		if (/<td>/i.test(this.getSelectedHTML())) {
			obj.tag="table";
			obj.count=1;
			return obj;
		}
	}
	var sss;
	if (HTMLArea.is_ie) {
		sss = this.getSelectedHTML();
	} else {
		if (range.commonAncestorContainer == "[object HTMLBodyElement]") {
			sss = this.getSelectedHTML(); 
		} else {
			sss = this.getSelectedHTMLCol(); 
		}
	}
	div.innerHTML = sss;
	var j=0;
	try{
		obj.tag=div.firstChild.tagName.toLowerCase();
	}catch(e) {
	}
	for(var i=0; i<div.childNodes.length; i++) {
		try{
			if (div.childNodes[i].nodeType==1) j++;
		}catch(e) {
		}
	}
	if (j>1) {
		obj.count=j;
		return obj;
	} else {
		obj.count=1;
		return obj;
	}
}

HTMLArea.prototype.getTagInSelection = function() {
	var obj=this.checkSelectionCol();
	if (obj.tag=="" || obj.tag=="img") {
		var tag=this.getParentElement();
		if (tag.tagName.toLowerCase()=="img") {
			tag=tag.parentNode;
		}
		obj.tag=tag.tagName.toLowerCase();
	}
	var i = obj.count;
	var sel = this._getSelection();
	var r=this._createRange(sel);
	var mas = new Array();		
	if (HTMLArea.is_ie) {
		if (r.htmlText=="") {
			var pt = this.getParentElement();
			mas[0]=pt;
			return mas;
		}
	} else {
		if (r.toString()=="") {
			var pt = this.getParentElement();
			mas[0]=pt;
			return mas;
		}
	}
	var t = 0;		
	if (HTMLArea.is_ie) {
		if (sel.type=="Control") {
			var p=r.item(0);
		} else {
			r.move("character");
			var p=r.parentElement()
		}
	} else {
		var p = r.commonAncestorContainer;
		if (!r.collapsed && r.startContainer == r.endContainer &&
			r.startOffset - r.endOffset <= 1 && r.startContainer.hasChildNodes())
			p = r.startContainer.childNodes[r.startOffset];
		if (p == "[object HTMLBodyElement]") {
			if (r.startContainer.parentNode=="[object HTMLHtmlElement]") {
				p = r.startContainer;
			} else {
				p = r.startContainer.parentNode;
			}
		}
		while (p.nodeType == 3) {
			p = p.parentNode;
		}
	}
	var e=0;
	if (p.tagName.toLowerCase()!=obj.tag) {
		while((p.tagName.toLowerCase()!=obj.tag) && (p.tagName.toLowerCase() != 'body')) {		
			if (HTMLArea.is_ie) {
				p=p.parentElement;
			} else {
				p = p.parentNode;
				while (p.nodeType == 3) {
					p = p.parentNode;
				}
			}
		}
	}
	try{
		if (p.tagName.toLowerCase()=="body") {
			p=p.firstChild;
			if (p=="[object Text]") {
				while (p=="[object Text]") {
					p=p.nextSibling;
				}
			}
			mas[t] = p;
			t++;
		} else {
			mas[t] = p;
			t++;
		}
	}catch(e) {
		mas[t] = p;
		t++;
	}
	if (i>1) {
		for(var j=1; j<i;j++) {
			try{
				p=p.nextSibling;
			}catch(e) {
			}
			if (p != null) {
				if (p=="[object Text]") {
					while (p=="[object Text]") {
						p=p.nextSibling;
					}
				}
				mas[t] = p;
				t++;
			}
		}
	}
	return mas;
}

HTMLArea.prototype.clearAlign = function(el) {
	try{
		for(var i=0;i<el.rows.length;i++) {
			var tr = el.rows[i];
			tr.style.textAlign = "";
			tr.align = "";
			for(var j=0;j<tr.cells.length;j++) {
				tr.cells[j].style.textAlign = "";
				tr.cells[j].align = "";
			}
		}
	}catch(e) {
	}
}

HTMLArea.prototype.clearAlignList = function(obj, param) {
	var li = obj.childNodes;
	try{
		obj.align = param;
		obj.style.textAlign = param;
	}catch(e) {
	}
	for (var i=0; i<li.length; i++) {
		try{
			if (li[i].tagName.toLowerCase()=="li") {
				li[i].align = param;
				li[i].style.textAlign = param;
				if (li[i].childNodes.length>0) {
					for(var j=0; j<li[i].childNodes.length;j++) {
						try{
							li[i].childNodes[j].align = param;
							li[i].childNodes[j].style.textAlign = param;
						}catch(e) {
						}
					}
				}
			}
		}catch(e) {
		}
	}
}

HTMLArea.prototype.checkLists = function(LT,cmdID,UI,param) {
	var an = this.getAllAncestors();
	try{
		var p = this._doc.getElementsByTagName("p");
		for(var i=0;i<p.length;i++) {
			if (p[i].innerHTML=="") {
				p[i].parentNode.removeChild(p[i]);
			}
		}
	}catch(e) {
	}
	
	var mm=this.getTagInSelection();
	var mm1 = new Array();
	for(var t=0; t<mm.length;t++) {
		mm1[t] = mm[t].cloneNode(true);
	}
	var mix = 0;
	for(var r=0;r<mm.length;r++) {
		if (mm[r].tagName.toLowerCase()!="ol"&&mm[r].tagName.toLowerCase()!="ul") {
			mix++;
		}
	}
	for(var r=0;r<mm.length;r++) {
		if (mm[r].tagName.toLowerCase()=="ol"||mm[r].tagName.toLowerCase()=="ul") {
			if ((mm[r].tagName.toLowerCase()=="ol"&&cmdID=="insertorderedlist")||(mm[r].tagName.toLowerCase()=="ul"&&cmdID=="insertunorderedlist")) {
				try{
					for(var i=0; i<mm[r].childNodes.length; i++) {
						if (mm[r].childNodes[i]=="[object Text]") {
							mm[r].removeChild(mm[r].childNodes[i]);
						}
					}
				}catch(e) {
				}
				try{
					var lis = mm[r].getElementsByTagName("li");
					for(var i=0; i<lis.length; i++) {
						var rr=false;
						for(var j=0; j<lis[i].childNodes.length; j++) {
							if (lis[i].childNodes[j]!="[object HTMLParagraphElement]" && lis[i].childNodes[j]!="[object HTMLHeadingElement]" && lis[i].childNodes[j]!="[object HTMLRpeElement]" && lis[i].childNodes[j]!="[object HTMLAddressElement]") rr=true;
						}
						if (rr) {
							if (mix==0) {
								lis[i].innerHTML = "<p style='"+mm[r].style.cssText+lis[i].style.cssText+"'>"+lis[i].innerHTML + "</p>";	
							}
						}
					}
				}catch(e) {
				}
			}
		}
		if (mm[r].tagName.toLowerCase()=="li") {
			if ((mm[r].parentNode.tagName.toLowerCase()=="ol"&&cmdID=="insertorderedlist")||(mm[r].parentNode.tagName.toLowerCase()=="ul"&&cmdID=="insertunorderedlist")) {
				try{
					var lis = mm[r];
					var rr=false;
					for(var j=0; j<lis.childNodes.length; j++) {
						if (lis.childNodes[j]!="[object HTMLParagraphElement]" && lis.childNodes[j]!="[object HTMLHeadingElement]" && lis.childNodes[j]!="[object HTMLRpeElement]" && lis.childNodes[j]!="[object HTMLAddressElement]") rr=true;
					}
					if (rr) {
						lis.innerHTML = "<p style='"+mm[r].parentNode.style.cssText+lis.style.cssText+"'>"+lis.innerHTML + "</p>";	
					}
				}catch(e) {
				}
			}
			this.selectNodeContents(mm[r]);
		}
		//this.selectNodeContents(mm[r]);
		//this._doc.execCommand(cmdID, UI, param);
	}
	if (an[0].tagName.toLowerCase()=="ol"||an[0].tagName.toLowerCase()=="ul") {
		this.selectNodeContents(an[0]);
	}
	this._doc.execCommand(cmdID, UI, param);
	an = this.getAllAncestors();
	if (an[0].tagName.toLowerCase()=="ol"||an[0].tagName.toLowerCase()=="ul"||an[0].tagName.toLowerCase()=="li") {
		if (an[0].tagName.toLowerCase()=="li") {
			var li = an[1].getElementsByTagName("li");
		} else {
			var li = an[0].getElementsByTagName("li");
		}
		var cssArr = new Array();
		var j=0;
		for(var i=0;i<mm1.length;i++) {
			if (mm1[i]=="[object HTMLParagraphElement]") {
				try{
					cssArr[j] = mm1[i].style.cssText;
					j++;
				}catch(e) {
				}
			}else if (mm1[i]=="[object HTMLOListElement]" || mm1[i]=="[object HTMLUListElement]") {
				var liLi = mm1[i].getElementsByTagName("li");
				for(var r=0;r<liLi.length;r++) {
					try{
						cssArr[j] = mm1[i].style.cssText+liLi[r].style.cssText;
						j++;
					}catch(e) {
					}
				}
			} else {
				try{
					cssArr[j] = mm1[i].style.cssText;
					j++;
				}catch(e) {
				}
			}
		}
		for(var i=0;i<li.length;i++) {
			try{
				li[i].style.cssText=cssArr[i];
			}catch(e) {
			}
		}
	}
}

HTMLArea.prototype.verTapName = function(mass) {
	for(var i=0;i<mass.length;i++) {
		if (HTMLArea.is_ie) {
			p=mass[i].parentElement;
		} else {
			p = mass[i].parentNode;
			while (p.nodeType == 3) {
				p = p.parentNode;
			}
		}		
		if (p.tagName.toLowerCase()=="p" || p.tagName.toLowerCase()=="adress" || p.tagName.toLowerCase()=="pre" || p.tagName.toLowerCase()=="h1" || p.tagName.toLowerCase()=="h2" || p.tagName.toLowerCase()=="h3" || p.tagName.toLowerCase()=="h4" || p.tagName.toLowerCase()=="h5" || p.tagName.toLowerCase()=="h6") {
			mass[i] = p;
		}		
	}
	return mass;
}

HTMLArea.prototype.retSelection = function() {
	try{
		var an1=this.getAllAncestors();
		if (an1[0].tagName.toLowerCase()=="table" || an1[0].tagName.toLowerCase()=="tbody" || an1[0].tagName.toLowerCase()=="tr") {
			if (an1[0].tagName.toLowerCase()=="table") {
				var tt = an1[0];
			}else if (an1[0].tagName.toLowerCase()=="tbody") {
				var tt = an1[1];
			}else if (an1[0].tagName.toLowerCase()=="tr") {
				var tt = an1[2];
			}
			var t1=tt;
			this.selectNodeContents(tt);
			this.insertNodeAtSelection(tt,true);
			if (an1[0].tagName.toLowerCase()=="tbody" || an1[0].tagName.toLowerCase()=="tr") {
				var p = tt.firstChild
				if (p=="[object Text]") {
					while (p=="[object Text]") {
						p=p.nextSibling;
					}
				}
				this.selectNodeContents(p);
			}
		}
		this._textArea.focus();
		this._iframe.contentWindow.focus();
	}catch(e) {
	}
}


HTMLArea.prototype.fShowBorders = function() {
	if (editor.showborders==true) {
		editor.showborders=false;
	} else {
		editor.showborders=true;
	}
	mvContent=setBody(HTMLArea.getHTML(this._doc.body, false));
	initIframe();
};

HTMLArea.prototype.modifyTag = function(el, dblc) {
	switch (el.tagName.toLowerCase()) {
		case 'a':
			this.fCreateLink();
			break;
		case 'table':
			this._insertTable(dblc);
			break;
		case 'img':
			var type="none";
			try{
				type=el.type;
				if (typeof type == "undefined") {
					var txtTag=HTMLArea.getHTML(el, true);
					if (/type=\"modules\"/.test(txtTag)) type = "modules";
				}
			}catch(e) {
					
			}
			if (type=="modules") {
				this.fModules(el.name);
				break;
			}
			this._insertImage();
			break;
		default: break;
	}
}

HTMLArea.prototype.CheckWordSelection = function() {
	if (HTMLArea.is_ie) return false;
	try{
		var sel = this._getSelection();
		var range = this._createRange(sel);
		if (range.toString()=="") {
			var point = range.startOffset;
			var node = this.getParentElement();
			var text = range.commonAncestorContainer.data;
			var end = point;
			var start = point;
			for(var i=point;i<text.length;i++) {
				var ch=text.charCodeAt(i)
				if (ch<48 || (ch>57 && ch<65) || (ch>90 && ch<97) || (ch>122 && ch<192)) {
					end = i;
					break;
				}
				end = i+1;
			}
			for(var i=point;i>(-1);i--) {
				var ch=text.charCodeAt(i)
				if (ch<48 || (ch>57 && ch<65) || (ch>90 && ch<97) || (ch>122 && ch<192)) {
					start = i+1;
					break;
				}
				start = i;
			}
			range.setStart(range.startContainer,start);
			range.setEnd(range.startContainer,end); 
			sel.removeAllRanges();
			sel.addRange(range);
		}
	}catch(e) {
		return false;
	}
}

HTMLArea.prototype.fCreateLink = function() {
	this._undoTakeSnapshot();
	var link=null;
	var editor = this;
	var obj=new Object;
	obj.imga=editor.config.editorURL+"/wysiwyg/images/arrow.gif";
	obj.sp2=sp2Detect(__trastedSite);
	obj.id=editor.mvPSID;
	obj.title=editor.mvTITLE;
	var sell=editor.getSelectedHTML();
	var val=/<img/i.test(sell);
	var outparam = null;
	var an=editor.getAllAncestors();
	try{
		var rr = editor.SelNode.tagName.toLowerCase();
	}catch(e) {
		var rr="none";
	}
	if (rr=="a") link=editor.SelNode;
	if (an[0].tagName.toLowerCase()=="img" && an[1].tagName.toLowerCase()=="a") {
		alert(fMessage("notallowedoperation"));
	return false;
	}
	if (link) {
		var text=link.innerHTML;
		outparam = {
			f_href   : link.getAttribute("href"),
			f_title  : link.title,
			f_target : link.target,
			f_text_dec : link.style.textDecoration,
			f_text : text
		};
	} else {
		var text=editor.getSelectedHTML();
		if (text) {
			var tt=text;
		} else {
			var tt="link";
		}
		outparam = {
			f_href   : "",
			f_title  : "",
			f_target : "none",
			f_text_dec : "",
			f_text : tt
		};
	}
	obj.param = outparam;
	obj.lang = Lang;
	this._popupDialog("link.html", function(param) {
		if (!param)
			return false;
		var a = link;
		if (!a) {
			var tagp=editor.getParentElement();
			if (HTMLArea.is_ie) {
				var ff="none";
			} else {
				var ff="";
			}
			var fs="";
			try{
				var value = ("" + doc.queryCommandValue("fontname")).toLowerCase();
				if (value!="") ff=value;
				var css=null;
				if (tagp.style.fontSize!="" && tagp.style.fontSize!="undefined") fs=tagp.style.fontSize;
				if (HTMLArea.is_ie) {
					css=doc.styleSheets[0].rules;
				} else {
					css=doc.styleSheets[0].cssRules;
				}
				for(var i=0;i<css.length;i++) {
					if (css[i].selectorText==".pageContent") {
						if (css[i].style.fontSize!="" && css[i].style.fontSize!="undefined" && fs=="") fs=css[i].style.fontSize;
						if (css[i].style.fontFamily!="" && css[i].style.fontFamily!="undefined" && (ff=="" || ff=="none")) ff=css[i].style.fontFamily;
						break;
					}
				}
			}catch(e) {
			}
			var a=editor._doc.createElement("a");
			var tag=tagp;
			var text = param.f_text;
			if (text) {
				var div = document.createElement("div");
				div.innerHTML = text;
				a.innerHTML = HTMLArea.getHTML(div, false);
			} else {
				var tt=param.f_href;
				while(tt.match('<') != null) {
					tt=tt.replace('<','&lt;');
				}
				while(tt.match('>') != null) {
					tt=tt.replace('>','&gt;');
				}
				a.innerHTML=tt;
			}
			a.href = param.f_href;
			a.style.fontFamily=tag.style.fontFamily;
			a.target = param.f_target;
			a.title = param.f_title;
			a.style.textDecoration = param.f_text_dec;
			a.style.fontFamily=ff;
			a.style.fontSize=fs;
			editor.insertNodeAtSelection(a, true);
		} else {
			var text = param.f_text;
			a.href = param.f_href;
			a.target = param.f_target;
			a.title = param.f_title;
			a.style.textDecoration = param.f_text_dec;
			var text = text;
			if (text) {
				var div = document.createElement("div");
				div.innerHTML = text;
				a.innerHTML = HTMLArea.getHTML(div, false);
			} else {
				var tt=param.f_href;
				while(tt.match('<') != null) {
					tt=tt.replace('<','&lt;');
				}
				while(tt.match('>') != null) {
					tt=tt.replace('>','&gt;');
				}
				a.innerHTML=tt;
			}
		}
		editor._undoTakeSnapshot();
		editor.selectNodeContents(a);
		editor.updateToolbar();
	}, obj);
};

HTMLArea.prototype.delEmptyTag = function() {
	var p = this._doc.getElementsByTagName("p");
	for(var i=0;i<p.length;i++) {
		if (p[i].innerHTML=="") {
			p[i].parentNode.removeChild(p[i]);
		}
	}
}

this.wrongSRC = null;
this._clc=false;
this.drag = false;

HTMLArea.prototype.editableContentResize = function() {
//	alert('DoResize');
	try{
		if (HTMLArea.is_ie) {
			this._iframe.style.height=this._doc.body.scrollHeight+this._doc.body.scrollTop+ 20 + "px";
			//this._divH=this._doc.body.scrollHeight+this._doc.body.scrollTop;
			this._iframe.style.width=editor.width;
			//this._divW=this._doc.body.scrollWidth+this._doc.body.scrollLeft;
			for(var i=0; i<this._TD.length; i++) {
				this._TD[i].style.height = "400px";
			}
		} else {
			
			var needHeight = this._iframe.contentDocument.height + 100 + 'px';
				if (this._iframe.style.height != needHeight) {
					this._iframe.style.height = needHeight;
				}			

			this._iframe.style.width="100%";
			for(var i=0; i<this._TD.length; i++) {
				this._TD[i].style.height = "400px";
			}
		}
	}catch(e) {
	}
}


var euroHotKeys = { 17:false,18:false,69:false };

HTMLArea.prototype._editorEvent = function(ev) {
	var editor = this;

    var e = ev || window.event;
    if (((euroHotKeys[e.keyCode] != undefined) || (euroHotKeys[e.keyCode] != null)) && (ev.type == "keydown")) {
        euroHotKeys[e.keyCode] = true;
    }
    if (euroHotKeys[17] && euroHotKeys[18] && euroHotKeys[69]) {
        euroHotKeys[17] = false; 
        euroHotKeys[18] = false;
        euroHotKeys[69] = false;
		HTMLArea._stopEvent(ev);
		this.insertHTML('&euro;');
    }

	if (ev.type == "dblclick") {
		var ancestors = this.getAllAncestors();
		if (ancestors[0].tagName.toLowerCase()=="img") {
			var el=this.getParentElement();
		} else {
			var el=this.SelNode;
		}
		try{
			if (el.nodeName.toLowerCase()=="a" || el.nodeName.toLowerCase()=="img" || el.nodeName.toLowerCase()=="table") {
				this.modifyTag(el, true);
			}
		}catch(e) {
		}
		HTMLArea._stopEvent(ev);
	}else if (ev.type == "dragdrop" || ev.type == "dragstart") {
		var ancestors = this.getAllAncestors();
		var str = this.getSelectedHTML();
		var sel = this._getSelection();
		var range = this._createRange(sel);
		var test = true;
		if (HTMLArea.is_ie) {
			if (/<td>/i.test(range.htmlText) && ancestors[0].tagName.toLowerCase()!="table") test=false;
			var str = this.getSelectedHTML();
			if (/<img/i.test(str)) test=false;
		} else {
			var str = this.getSelectedHTML();
			if (/<img/i.test(str)) test=false;
			if (/<td>/i.test(str) && range.startContainer.childNodes[range.startOffset] != "[object HTMLTableElement]") test=false;
		}
		if (test) {
			setTimeout(function() {
				editor.clearTagIfImage();
			}, 50);
			setTimeout(function() {
				editor.updateToolbar();
			}, 50);
		} else {
			HTMLArea._stopEvent(ev);
		}
	} else {
		var keyEvent = (HTMLArea.is_ie && ev.type == "keydown") || (ev.type == "keypress");
		if (keyEvent) {
			if (ev.shiftKey) {
				this.key="0";
			} else {
				if (this.mvPType=="HTML") {
					var kc=ev.keyCode;
					var cc = String.fromCharCode(HTMLArea.is_ie ? ev.keyCode : ev.charCode).toLowerCase();
					this.key = cc;
					if (kc!=0) {
						this.key = ""+kc;
					}
				}
			}

		var ancestors = this.getAllAncestors();
		if (this.mvPType!="HTML") {
			//alert(fMessage("notallowedoperation"));
			HTMLArea._stopEvent(ev);
			return true;
		}

		if (ev.keyCode==13) {
			if (ancestors[0].tagName.toLowerCase()=="img") {
				HTMLArea._stopEvent(ev);
			}
		}

		if (ev.keyCode==46||ev.keyCode==8) {//
			var sel = this._getSelection();
			var range = this._createRange(sel);
			var p = range.commonAncestorContainer;
			var obj=this.checkSelectionCol();
			var txt = "";
			if (HTMLArea.is_ie) {
				txt = range.htmlText;
			}
			var txt1 = this.getSelectedHTML();
			var tn = this.getSelectedHTMLCol();
			for(var i=0; i<ancestors.length; i++) {
				if (ancestors[i].tagName.toLowerCase()=="tr" || ancestors[i].tagName.toLowerCase()=="td")
					break;
				if (ancestors[i].tagName.toLowerCase()=="table" ||ancestors[i].tagName.toLowerCase()=="caption") {
					ancestors[i+1].removeChild(ancestors[i]);
					HTMLArea._stopEvent(ev);
					break;
				}else if (ancestors[i].tagName.toLowerCase()=="tbody") {
					ancestors[i+2].removeChild(ancestors[i+1]);
					HTMLArea._stopEvent(ev);
					break;
				} 
			}
			if (ancestors[0].tagName.toLowerCase()=="img" && ancestors[1].tagName.toLowerCase()=="a") {
				try{
					this.setCursorAtNode(ancestors[1]);
					ancestors[2].removeChild(ancestors[1]);
					HTMLArea._stopEvent(ev);
				}catch(e) {
				}
			}else if (txt1==ancestors[0].innerHTML && ancestors[0]=="[object HTMLSpanElement]") {
				try{
					this.setCursorAtNode(ancestors[0]);
					ancestors[1].removeChild(ancestors[0]);
					HTMLArea._stopEvent(ev);
				}catch(e) {
				}
			}else if ((obj.tag=="font" && /<font/i.test(txt))||(ancestors[0]=="[object HTMLFontElement]" && txt1==ancestors[0].innerHTML)) {
				try{
					this.setCursorAtNode(ancestors[0]);
					ancestors[1].removeChild(ancestors[0]);
					HTMLArea._stopEvent(ev);
				}catch(e) {
				}
			}else if ((txt1!=""&&txt1.length>=ancestors[0].innerHTML.length)&&((ancestors[0].tagName.toLowerCase()=="h1"&&/<h1/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="h2"&&/<h2/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="h2"&&/<h2/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="h4"&&/<h4/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="h5"&&/<h5/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="h6"&&/<h6/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="pre"&&/<pre/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="address"&&/<address/i.test(tn))||(ancestors[0].tagName.toLowerCase()=="p"&&/<p/i.test(tn)))) {
				try{
					this.setCursorAtNode(ancestors[0]);
					ancestors[1].removeChild(ancestors[0]);
					HTMLArea._stopEvent(ev);
				}catch(e) {
				}
			}else if (ancestors[0].innerHTML=="") {
				try{
					this.setCursorAtNode(ancestors[0]);
					ancestors[1].removeChild(ancestors[0]);
					HTMLArea._stopEvent(ev);
				}catch(e) {
				}
			}else if ((ancestors[0].tagName.toLowerCase()=="ul"||ancestors[0].tagName.toLowerCase()=="ol")) {
				this.delEmptyTag();
				var t = ancestors[0].innerHTML;
				var t1 = this.getSelectedHTML();
				while(/&nbsp;/.test(t)) {
				   t=t.replace("&nbsp;"," ");
				}
				while(/&nbsp;/.test(t1)) {
				   t1=t1.replace("&nbsp;"," ");
				}
				t1=escape(t1);
				t=escape(t);
				while(/%0D%0A/.test(t)) {
				   t=t.replace("%0D%0A","");
				}
				while(/%3CBR%3E/.test(t)) {
				   t=t.replace("%3CBR%3E","");
				}
				while(/%3CBR%3E/.test(t1)) {
				   t1=t1.replace("%3CBR%3E","");
				}
				while(/C2%A0/.test(t1)) {
				   t1=t1.replace("C2%A0","20");
				}
				while(/%0D%0A/.test(t1)) {
				   t1=t1.replace("%0D%0A","");
				}
				while(/%0A/.test(t1)) {
				   t1=t1.replace("%0A","");
				}
				if (t.toLowerCase()==t1.toLowerCase()) {
					this.setCursorAtNode(ancestors[0]);
					ancestors[1].removeChild(ancestors[0]);
					HTMLArea._stopEvent(ev);
				}
			}
		}

		if (ev.keyCode==8) {
			var del=false;
			var an = this.getAllAncestors();
			for(var j=0;j<an.length-1;j++) {
				try{
					var ml= parseInt(an[j].style.marginLeft);
					if (ml>0) {
						if (ml>39 && (ml/40==parseInt(ml/40))) {
							del=true;
							break;
						}
					}
				}catch(e) {
				}
			}
			var dd=false;
			if (HTMLArea.is_ie) {
			var rng = document.selection.createRange();
				rng.expand("word");
				var tg=an[0].innerHTML.substr(0,rng.text.length);
				if (tg==rng.text && rng.text!="") dd=true;
			} else {
				var sel = this._getSelection();
				var range = this._createRange(sel);
				if (range.startOffset==0) dd=true;
			}
			if (dd && del) {
				this.execCommand("outdent");
				HTMLArea._stopEvent(ev);
			}
		}
		if (ev.keyCode==9 && !ev.shiftKey) {
			var str = this.getSelectedHTML();
			var ancestors = this.getAllAncestors();
			var tdLast=false;
			var trLast=false;
			if (ancestors[0].tagName.toLowerCase()=="td") {
				if (ancestors[1].cells.length == (ancestors[0].cellIndex+1)) tdLast=true;
				if (ancestors[2].rows.length == (ancestors[1].rowIndex+1)) trLast=true;
			}
			var test = false;
			if (tdLast && trLast) test=true;
			if (str=="" && !test) {
				this.insertHTML("&#160;&#160;&#160;");
			}else if (str=="" && test) {
				this.plugins["TableOperations"].buttonPress(editor,"TO-row-insert-under");
				this.selectNodeContents(ancestors[0]);
			} else {
				//if (ancestors[0].tagName.toLowerCase()=="body") {
				//} else {
						this.execCommand("indent");
				//}
			}
			HTMLArea._stopEvent(ev);
		}
	}
	if (keyEvent && ev.shiftKey) {
		var sel = null;
		var range = null;
		var key = ev.keyCode;
		var cmd = null;
		var value = null;
		switch (key) {
			case 9: 
				cmd = "outdent"; 
				break;
		}
		if (cmd) {
			this.execCommand(cmd, false, value);
			HTMLArea._stopEvent(ev);
		}
	}
	if (keyEvent && ev.ctrlKey) {
		var sel = null;
		var range = null;
		var key = String.fromCharCode(HTMLArea.is_ie ? ev.keyCode : ev.charCode).toLowerCase();
		var cmd = null;
		var cmd_copy = null;
		var value = null;
		switch (key) {
			case 'a':
				if (!HTMLArea.is_ie) {
					// KEY select all
					sel = this._getSelection();
					sel.removeAllRanges();
					range = this._createRange();
					range.selectNodeContents(this._doc.body);
					sel.addRange(range);
					HTMLArea._stopEvent(ev);
				}
				break;
			case 'b': cmd = "bold"; break;
			case 'i': cmd = "italic"; break;
			case 'u': cmd = "underline"; break;
			case 's': cmd = "strikethrough"; break;
			case 'l': cmd = "justifyleft"; break;
			case 'e': cmd = "justifycenter"; break;
			case 'r': cmd = "justifyright"; break;
			case 'j': cmd = "justifyfull"; break;
			case 'z': cmd = "undo"; break;
			case 'y': cmd = "redo"; break;
			case 'c': cmd_copy = "copy"; break;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
				cmd = "formatblock";
				value = "h" + key;
				if (HTMLArea.is_ie) {
						value = "<" + value + ">";
				}
				break;
		}
		if (cmd_copy) {
			if (/type=([\"|\'])modules([\"|\'])/i.test(this.getSelectedHTML())) {
				alert(fMessage("notallowedoperation"));
				HTMLArea._stopEvent(ev);
			}
		}
		if (cmd) {
			this.execCommand(cmd, false, value);
			HTMLArea._stopEvent(ev);
		}
	}
	
	if (keyEvent && !ev.ctrlKey&&ev.keyCode==0) {
		var an1 = this.getAllAncestors();
		if (String.fromCharCode(HTMLArea.is_ie ? ev.keyCode : ev.charCode).toLowerCase()!=""&&an1[0].tagName.toLowerCase()=="tbody") {
			an1[2].removeChild(an1[1]);
		}else if (String.fromCharCode(HTMLArea.is_ie ? ev.keyCode : ev.charCode).toLowerCase()!=""&&(an1[0].tagName.toLowerCase()=="tr")) {
			HTMLArea._stopEvent(ev);
			alert(fMessage("notallowedoperation"));
		}
	}
	if (editor._timerToolbar) {
		clearTimeout(editor._timerToolbar);
	}
	editor._timerToolbar = setTimeout(function() {
		editor.updateToolbar();
		editor._timerToolbar = null;
	}, 50);
	}
	this.editableContentResize();
};

HTMLArea.prototype.getHTML = function() {
	switch (this._editMode) {
		case "wysiwyg"  :
			if (mvMode=="html") {
				return setBody(this._doc.body.innerHTML);
			} else {
				return getBody(mvContent);
			}
			break;
		case "html" :
			mvContent=this._textArea.value;
			if (mvMode=="html") {
				return mvContent;
			} else {
				return getBody(this._textArea.value);
			}
			break;
		case "preview"  :
			if (mvMode=="html") {
				return mvContent;
			} else {
				return getBody(mvContent);
			}
			break;
		default  : alert(fMessage("mode") + this._editMode  + fMessage("notdefined"));
	}
	return false;
};

HTMLArea.prototype.getHTMLOut = function() {
	try{
		var allStrong = this._doc.getElementsByTagName("strong");
		var b=null;
		while(allStrong.length>0) {
			for(var i=0; i<allStrong.length; i++) {
				b = this._doc.createElement("b");
				b.innerHTML = allStrong[i].innerHTML;
				allStrong[i].replaceNode(b);
			}
			allStrong = this._doc.getElementsByTagName("strong");
		}  
	}catch(e) {
	}
	var htmlsource="";
	try{
		switch (this._editMode) {
			case "wysiwyg"  : htmlsource=HTMLArea.getHTML(this._doc.body,false);break;
			case "html" : htmlsource=this._textArea.value; break;
			case "preview"  : htmlsource=mvContent; break;
			default			: alert(fMessage("mode") + this._editMode  + fMessage("notdefined"));
		}
		return htmlsource;
	}
	catch(e)
	{
		return '';
	}
};

HTMLArea.prototype.getStrStyle = function(tag) {
	var stl="";
	try{
		stl = tag.style.cssText;
	}catch(e) {
	}
	if (stl!="") {
		return 'style="'+stl+'"';
	} else {
		return "";
	}
}

HTMLArea.prototype.getInnerHTML = function() {
	switch (this._editMode) {
		case "wysiwyg"  :
			try{   
				return setBody(this._doc.body.innerHTML);
			}catch(e) {
			}
			break;
		case "html" :
			mvContent=this._textArea.value;
			if (mvMode=="html") {
				return mvContent;
			} else {
				return getBody(this._textArea.value);
			}
			break;
		case "preview"  :
			if (mvMode=="html") {
				return mvContent;
			} else {
				return getBody(mvContent);
			}
			break;
		default : alert(fMessage("mode") + this._editMode  + fMessage("notdefined"));
	}
	return false;
};

this._snap=false;

HTMLArea.prototype.setHTML = function(html, AURL) {
	vURL=AURL;
	f="";
	if (vURL && vURL!="" && typeof vURL!="undefined") {
		f= '<BASE href="' + vURL + '">';
	}
	var valHTM;
	switch (this._editMode) {
		case "wysiwyg"  :
		   try{
				this._doc.body.innerHTML=delEmptyTag(getBody(html));
				
			}catch(e) {
			}
			break;
		case "html" : this._textArea.value = setBody(delEmptyTag(html)); break;
		case "preview"  : this._doc.body.innerHTML=getBody(html);break;
		default  : alert("Mode <" + mode + "> not defined!");
	}
	try{
		if (HTMLArea.is_ie) {
			this._iframe.style.height=this._doc.body.scrollHeight+this._doc.body.scrollTop + 20 +"px";
			this._iframe.style.width=editor.width;
		} else {
			this._iframe.style.height=this._doc.body.scrollHeight+this._doc.body.scrollTop + 25 +"px";
			this._iframe.style.width="100%";
		}
	}catch(e) {
	}
	
	this.updateToolbar();
	return false;
};

HTMLArea.prototype._getSelection = function() {
	if (HTMLArea.is_ie) {
		try{
			var sel = this._iframe.contentWindow.document.selection;
		}catch(e) {
			var sel = null;
		}
		return sel;

	} else {
		return this._iframe.contentWindow.getSelection();
	}
};

HTMLArea.prototype._createRange = function(sel) {
	if (HTMLArea.is_ie) {
		if (sel==null) {
			return null;
		} else {
			return sel.createRange();
		}
	} else {
		this.focusEditor();
		if (typeof sel == "undefined" || sel == null) {
			var r=null;
			try{
				r=this._doc.createRange();
			}catch(e) {
			}
			return r;
		} else {
			var r=null;
			try{
				r= sel.getRangeAt(0);
			}catch(e) {
			}
			return r;
		}
	}
};

HTMLArea.prototype.getParentElement1 = function() {
	var sel = this._getSelection();
	var range = this._createRange(sel);
	if (HTMLArea.is_ie) {
		return range.parentElement ? range.parentElement() : this._doc.body;
	} else {
		var p = range.commonAncestorContainer;
		while (p.nodeType == 1) {
			p = p.parentNode;
		}
		return p;
	}
};

HTMLArea.prototype._popupDialog = function(url, action, init) {
	Dialog(this.popupURL(url), action, init);
};

HTMLArea.prototype.imgURL = function(file, plugin) {
	if (typeof plugin == "undefined") {
		return this.config.editorURL + "/"+file;
	} else {
		return this.config.editorURL + "/wysiwyg/plugins/" + plugin + "/img/" + file;
	}
};

HTMLArea.prototype.popupURL = function(file) {
	return this.config.editorURL + this.config.popupURL + file;
};

var mvInsertedId=0;
HTMLArea.prototype.fInsertHtmlObject = function(HTML) {
	this.insertHTML(HTML);
	return 0;
};

HTMLArea.prototype.sSelectAll= function() {
	editor.selectNodeContents(this._doc.body);
};

HTMLArea.prototype.isModule = function() {
	var ancestors = this.getAllAncestors();
	var tp="none";
	try{
		tp=ancestors[0].type;
		if (ancestors[0].tagName.toLowerCase()=="img" && typeof tp == "undefined") {
			var txtTag=HTMLArea.getHTML(ancestors[0], true);
			if (/type=\"modules\"/.test(txtTag)) tp = "modules";
			if (/type=modules/.test(txtTag)) tp = "modules";
		}
	}catch(e) {
	}
	if (tp=="modules") {
		return true;
	} else {
		return false;
	}
}

HTMLArea.prototype.fDellModules = function() {
	var ancestors = this.getAllAncestors();
	try{
		ancestors[1].removeChild(ancestors[0]);
	}catch(e) {
	}
	this.updateToolbar();
}

var objPP=null;
var strText="&#160;";

HTMLArea.prototype.fModules = function(param) {
	this._undoTakeSnapshot();
	if (typeof param == "object") {
		var tm=param.name;
		var an = new Array();
		an[0]=param;
	} else {
		var tm=param;
		var an = this.getAllAncestors();
	}
	var test = false;
	for(g=0;g<masMod1.length;g++) {
		if (masMod1[g].id.toLowerCase()==tm.toLowerCase()) test = true;
	}
	if (!test) {
		alert(fMessage("notallowedoperation"));
		return false;
	}
	var type="none";
	try{
		type=an[0].type;
		if (an[0].tagName.toLowerCase()=="img" && typeof type == "undefined") {
			var txtTag=HTMLArea.getHTML(an[0], true);
			if (/type=\"modules\"/.test(txtTag)) type = "modules";
		}
	}catch(e) {	 
	}
	if (an[0].tagName.toLowerCase()=="img" && type=="modules") {
		var colorBorder="#000000";
		try{
			var css=null;
			if (document.all) {
				css=doc.styleSheets[0].rules;
			} else {
				css=doc.styleSheets[0].cssRules;
			}			
			for(var i=0;i<css.length;i++) {
				if (css[i].selectorText==".pageContent") {
					if (css[i].style.color=="undefined") {
						//colorLink="red";
					} else {
						colorBorder=css[i].style.color;
					}
					break;
				}
			}
		}catch(e) {
		}
		document.forms[0].m_color.value = colorBorder;
		document.forms[0].topic.value='mod_'+an[0].name;
		document.forms[0].mode.value='edit';
		document.forms[0].modules_id.value=an[0].id;
		doSave(true);
	} else {
		var ppDate = new Date();
		var id=tm+ppDate.getDate().toString()+ppDate.getMonth().toString()+ppDate.getFullYear().toString()+ppDate.getHours().toString()+ppDate.getMinutes().toString()+ppDate.getSeconds().toString();
		this.focusEditor();
		this.insertHTML('<img type="modules" height="70" alt="'+tm+'" src="'+getSiteUrl()+'/wysiwyg/php/generateimag.php?name='+tm+'" name="'+tm+'" id="'+id+'">');
		this.editableContentResize();
	}
	this._undoTakeSnapshot();
}

HTMLArea.prototype.fFinde = function() {
	this._undoTakeSnapshot();
	var myObject = new Object();
	myObject.sp2=sp2Detect(__trastedSite);
	myObject.imga=this.config.editorURL+"/wysiwyg/images/arrow.gif";
	var e,r,t,y,e1,r1;
	idd=0;
	arrData=new Array();
	arrElement=new Array();
	HTMLArea.getHTML(doc.body,false);
	var sel = this._getSelection();
	var range1 = this._createRange(sel);
	var range = this._createRange();
	myObject.lang=Lang;
	myObject.seln=sel;
	myObject.range=range;
	myObject.doc=doc;
	if (HTMLArea.is_ie) {
		myObject.SEL=escape(range1.text);
	} else {
		myObject.SEL=escape(range1);
	}
	myObject.data=arrData;
	myObject.ell=arrElement;
	this._popupDialog("find.html", function(symbol) {
		if (symbol) {
			null;
		}
		editor.focusEditor();
		editor._undoTakeSnapshot();
		editor.updateToolbar();
	}, myObject);
	this._undoTakeSnapshot();
};

var mvTopF,mvTop,mvLeftF,mvLeft,mvHeightF,mvHeight,mvWidthF,mvWidth,hal,hat,haw,hah,y1,y2,y3,x1,x2,x3,mvScrX,mvScrY,mvTop,mvLeft,mvHight,mvWidth,mvATop,mvALeft,mvAWidth,mvAHeight,mvOHeight,mvOWidth,mvIHeight,mvIWidth;
HTMLArea.prototype.fFullscreen = function() {
	if (editor.fullscreen==true) {
		editor.fullscreen=false;
	} else {
		editor.fullscreen=true;
	}
	if (HTMLArea.is_ie) {
		this.full_screen_ie();
	} else {
		this.full_screen_other();
	}
	var temp=mvLeftF;
	if (temp == null || temp == "undefined" || temp == "") {
		temp="none";
	}
	document.getElementsByName("sb_mvLeftF").item(0).value=temp;
	editor.FSOP.mvLeftF=temp;

	editor.FSOP.mvLeft = getCoordinateValue("sb_mvLeft", mvLeft);
	editor.FSOP.mvTopF = getCoordinateValue("sb_mvTopF", mvTopF);
	editor.FSOP.mvTop = getCoordinateValue("sb_mvTop", mvTop);
	editor.FSOP.mvWidthF = getCoordinateValue("sb_mvWidthF", mvWidthF);
	editor.FSOP.mvWidth = getCoordinateValue("sb_mvWidth", mvWidth);
	editor.FSOP.mvHeightF = getCoordinateValue("sb_mvHeightF", mvHeightF);
	editor.FSOP.mvHeight = getCoordinateValue("sb_mvHeight", mvHeight);
	editor.FSOP.hah = getCoordinateValue("sb_hah", hah);
	editor.FSOP.haw = getCoordinateValue("sb_haw", haw);
	editor.FSOP.hat = getCoordinateValue("hat", hat);
	editor.FSOP.hal = getCoordinateValue("sb_hal", hal);
	editor.FSOP.x1 = getCoordinateValue("sb_x1", x1);
	editor.FSOP.y1 = getCoordinateValue("sb_y1", y1);
	editor.FSOP.x3 = getCoordinateValue("sb_x3", x3);
	editor.FSOP.mvOHeight = getCoordinateValue("sb_mvOHeight", mvOHeight);
	editor.FSOP.mvOWidth = getCoordinateValue("sb_mvOWidth", mvOWidth);
	editor.FSOP.mvScrX = getCoordinateValue("sb_mvScrX", mvScrX);
	
	temp=document.getElementsByName("sb_mvScrY").item(0).value;
};

HTMLArea.prototype.setTagProperties = function(tag) {
	try{
		if (tag.tagName.toLowerCase()=="tr") {
			for(var i=0; tag.cells.length; i++) {
				tag.cells[i].style.textAlign="";
				tag.cells[i].align="";
			}
		}else if (tag.tagName.toLowerCase()=="table") {
			el = tag.firstChild;
			if (el=="[object Text]") {
				  while (el=="[object Text]") {
					   el=el.nextSibling;
				   }
			 }
			for(var i=0;i<el.rows.length;i++) {
				var tr = el.rows[i];
				tr.style.color="";
				tr.style.backgroundColor = "";
				for(var j=0;j<tr.cells.length;j++) {
					tr.cells[j].style.color="";
					tr.cells[j].style.backgroundColor = "";
				}
			}
		}
	}catch(e) {
	}
	try{
		var tttt = this.tagToEdit.parentNode;
		tttt.replaceChild(tag, this.tagToEdit);
		this.tagToEdit = null;
		this.selectNodeContents(tag);
		this.updateToolbar();
	}catch(e) {
	}
	this._undoTakeSnapshot();
}

HTMLArea.prototype.TagProperty = function() {
	this._undoTakeSnapshot();
	var ancestors = editor.getAllAncestors();
	var el=editor._LastTT;
	this.tagToEdit=el;
	this.verAttribute();
	var ppDate = new Date();
	var id = ppDate.getDate().toString()+
			ppDate.getMonth().toString()+ppDate.getFullYear().toString()+
			ppDate.getHours().toString()+ppDate.getMinutes().toString()+
			ppDate.getSeconds().toString();
	winProp = window.open(getSiteUrl()+"/wysiwyg/php/tagedit.php?tag="+el.tagName.toLowerCase()+"&cid="+id, 
							"_dialog_tag_properties",
		"toolbar=no,menubar=no,modal=yes,dialog=yes,personalbar=no,width=400,height=400," +
		"scrollbars=no,resizable=no,status=no");
	return false;
};

HTMLArea.prototype.TagStl = function(params, element) {
	editor._undoTakeSnapshot();
	var ancestors = editor.getAllAncestors();
	var el=editor._LastTT;
	this.tagToEdit=el;
	this.verAttribute();
	var te = true;
	if (el.tagName.toLowerCase()=="table" || 
		el.tagName.toLowerCase()=="tbody" || 
		el.tagName.toLowerCase()=="tr" || 
		el.tagName.toLowerCase()=="img" || 
		el.tagName.toLowerCase()=="hr") te=false;
	var ppDate = new Date();
	var id = ppDate.getDate().toString()+
				ppDate.getMonth().toString()+ppDate.getFullYear().toString()+
				ppDate.getHours().toString()+ppDate.getMinutes().toString()+
				ppDate.getSeconds().toString();
	winStl = window.open(getSiteUrl()+"/wysiwyg/php/tagedit.php?tag="+el.tagName.toLowerCase()+"&te="+te+"&cid="+id, 
							"_dialog_tag_css_properties",
							"toolbar=no,menubar=no,modal=yes,dialog=yes,personalbar=no,width=400,height=400," +
							"scrollbars=no,resizable=no,status=no");
	return false;
};

HTMLArea.prototype.verAttribute = function() {
	if (this.tagToEdit.tagName.toLowerCase()=="td") {
		if (this.tagToEdit.style.textAlign=="" || this.tagToEdit.style.textAlign=="undefined") {
			if (this.tagToEdit.parentNode.style.textAlign == "" || 
				this.tagToEdit.parentNode.style.textAlign == "undefined") {
				this.tagToEdit.style.textAlign = this.tagToEdit.parentNode.parentNode.parentNode.style.textAlign;
			} else {
				this.tagToEdit.style.textAlign = this.tagToEdit.parentNode.style.textAlign;
			}
		}
		if (this.tagToEdit.style.verticalAlign=="" || 
			this.tagToEdit.style.verticalAlign=="undefined") {
			if (this.tagToEdit.parentNode.style.verticalAlign == "" || 
				this.tagToEdit.parentNode.style.verticalAlign == "undefined") {
				this.tagToEdit.style.verticalAlign = this.tagToEdit.parentNode.parentNode.parentNode.style.verticalAlign;
			} else {
				this.tagToEdit.style.verticalAlign = this.tagToEdit.parentNode.style.verticalAlign;
			}
		}
		if (this.tagToEdit.style.color=="" || this.tagToEdit.style.color=="undefined") {
			if (this.tagToEdit.parentNode.style.color == "" || this.tagToEdit.parentNode.style.color == "undefined") {
				this.tagToEdit.style.color = this.tagToEdit.parentNode.parentNode.parentNode.style.color;
			} else {
				this.tagToEdit.style.color = this.tagToEdit.parentNode.style.color;
			}
		}
		if (this.tagToEdit.style.backgroundColor=="" || this.tagToEdit.style.backgroundColor=="undefined") {
			if (this.tagToEdit.parentNode.style.backgroundColor == "" || 
				this.tagToEdit.parentNode.style.backgroundColor == "undefined") {
				this.tagToEdit.style.backgroundColor = this.tagToEdit.parentNode.parentNode.parentNode.style.backgroundColor;
			} else {
				this.tagToEdit.style.backgroundColor = this.tagToEdit.parentNode.style.backgroundColor;
			}
		}
	}else if (this.tagToEdit.tagName.toLowerCase()=="tr") {
		if (this.tagToEdit.style.textAlign == "" || this.tagToEdit.style.textAlign == "undefined") {
			this.tagToEdit.style.textAlign = this.tagToEdit.parentNode.parentNode.style.textAlign;
		}
		if (this.tagToEdit.style.verticalAlign == "" || this.tagToEdit.style.verticalAlign == "undefined") {
			this.tagToEdit.style.verticalAlign = this.tagToEdit.parentNode.parentNode.style.verticalAlign;
		}
		if (this.tagToEdit.style.color == "" || this.tagToEdit.style.color == "undefined") {
			this.tagToEdit.style.color = this.tagToEdit.parentNode.parentNode.style.color;
		}
		if (this.tagToEdit.style.backgroundColor == "" || this.tagToEdit.style.backgroundColor == "undefined") {
			this.tagToEdit.style.backgroundColor = this.tagToEdit.parentNode.parentNode.style.backgroundColor;
		}
	}
}

var arrWord=new Array;
HTMLArea.prototype.fSpell = function() {
	arrData=new Array();
	arrElement=new Array();
	arrWord=new Array();
	idd=0;
	HTMLArea.getHTML(doc.body,false);
	var sel = this._getSelection();
	var range = this._createRange();
	myObject.seln=sel;
	myObject.lang=Lang;
	myObject.range=range;
	myObject.doc=doc;
	myObject.data=arrData;
	myObject.ell=arrElement;
	myObject.sp2=sp2Detect(__trastedSite);
	myObject.imga=this.config.editorURL+"/wysiwyg/images/arrow.gif";
	if (document.all)
	{
		foo=editor._iframe.contentWindow;
		myObject.foo=editor._iframe.contentWindow;
		arr = getWords();
		rng = getRange();
	} else {
		var k=0;
		for(var i=0;i<arrData.length;i++) {
			var txt=arrData[i].data;
			var re=/[A-Za-z']/;
			var s="",id=-1,str="";
			for(j=0;j<txt.length;j++) {
				str=txt.substr(j,1,1);
				var tmp=str.match(re);
				if (tmp) {
					if (id<0) {
						id=j;
					}
					s=s+str;
					if (j==txt.length-1) {
						if (s != "") {
							arrWord[k]=new oWord(id,s,arrData[i]);
							k++;
						}
						s="";
						id=-1;
						str="";
					}
				} else {
					if (s != "") {
						arrWord[k]=new oWord(id,s,arrData[i]);
						k++;
					}
					s="";
					id=-1;
					str="";
				}		
			}		
		}
	}
	if (document.all)
		{
			myObject.arr=arr;
		} else {
			myObject.arr=arrWord;
		}
	this._popupDialog("spell.html", function(symbol) {
		if (symbol) { 
			null;
		}
	}, myObject);
};
