// htmlArea v3.0 - Copyright (c) 2002-2004 interactivetools.com, inc.
// This copyright notice MUST stay intact for use (see license.txt).
//
// Portions (c) dynarch.com, 2003-2004
//
// A free WYSIWYG editor replacement for <textarea> fields.
// For full source code and docs, visit http://www.interactivetools.com/
//
// Version 3.0 developed by Mihai Bazon.
//   http://dynarch.com/mishoo
//
// Portions (c) Copyright 2004-2005 SWsoft, Inc. http://www.swsoft.com
//

function PopupWin(editor, title, handler, initFunction) {
	this.editor = editor;
	this.handler = handler;
	
	var dlg = window.open("", "__ha_dialog",
			"toolbar=no,menubar=no,modal=yes,dialog=yes,personalbar=no,width=600,height=600," +
			"scrollbars=no,resizable=no,status=no");
	this.window = dlg;
	editor.win=dlg;
	var doc = dlg.document;
	this.doc = doc;
	var self = this;
	var base = document.baseURI || document.URL;
	if (base && base.match(/(.*)\/([^\/]+)/)) {
	  	base = RegExp.$1 + "/";
	}
	this.baseURL = base;
	doc.open();
	var html = "<html><head><title>" + title + "</title>\n";
	html += "<script language='javascript'>function doUnload() { try{opener.doUnload();}catch(e) {}}</script>"
	html += "<style type='text/css'>@import url(" + editor.config.editorURL + "/wysiwyg/htmlarea.css);</style></head>\n";
	html += "<body class='dialog popupwin' id='--HA-body' onunload='doUnload();'></body></html>";
	doc.write(html);
	doc.close();
	
	function init2() {
		var body = doc.body;
		if (!body) {
	  		setTimeout(init2, 25);
	  		return false;
		}
		dlg.title = title;
		doc.documentElement.style.padding = "0px";
		doc.documentElement.style.margin = "0px";
		var content = doc.createElement("div");
		content.className = "content";
		self.content = content;
		body.appendChild(content);
		self.element = body;
		initFunction(self);
		dlg.focus();
	};
	init2();
};


function doUnload() {
	try{
		editor.win=null;
  	}catch(e) {
  	}
}

PopupWin.prototype.callHandler = function() {
	var tags = ["input", "textarea", "select"];
	var params = new Object();
	for (var ti in tags) {
		var tag = tags[ti];
		var els = this.content.getElementsByTagName(tag);
		for (var j = 0; j < els.length; ++j) {
			var el = els[j];
		  	var val = el.value;
		  	if (el.tagName.toLowerCase() == "input") {
				if (el.type == "checkbox") {
			  		val = el.checked;
				}
		  	}
		  	params[el.name] = val;
		}
	}
	this.handler(this, params);
	return false;
};

PopupWin.prototype.close = function() {
	this.window.close();
};

PopupWin.prototype.addButtons = function() {
	var self = this;
	var div = this.doc.createElement("div");
	this.content.appendChild(div);
	div.className = "buttons";
	var btn;
	btn = arguments[0];
	var button;
	button = this.doc.createElement("button");
	div.appendChild(button);
	button.innerHTML = fMessage("ok");
	
	button.onclick = function() {
		var validVal=true;
		var tm=self.doc.getElementById("f_spacing");
		var tmt;
		if(tm!=null) {
			if((/[^0-9]/.test(tm.value)==false) && (parseInt(tm.value)>(-1) && parseInt(tm.value)<101)) {	   
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_padding");  
		if(tm!=null) {
			if((/[^0-9]/.test(tm.value)==false) && (parseInt(tm.value)>(-1) && parseInt(tm.value)<101)) {	   
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_size"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_lt");
		if(tm!=null) {
			if(tm.value=="") {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			} else {
			}
		}
		tm=self.doc.getElementById("f_ml"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_width");  
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_height"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_borders");  
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_border"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_cols"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_rows"); 
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		} 
		tm=self.doc.getElementById("f_st_width");
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_st_height");  
		if(tm!=null) {
			if(/[^0-9]/.test(tm.value)==false) {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		tm=self.doc.getElementById("f_st_borderWidth"); 
		if(tm!=null) {
			if(tm.style.visibility=="hidden") {
				tm.value=0;
			}
			if(/[^0-9]/.test(tm.value)==false && tm.value!="") {
			} else {
				alert(fMessage("no_valid_fields_value"));
				tm.focus(); tmt=tm;
				validVal=false;
			}
		}
		if(validVal) {
			try{
				editor.win=null;
			} catch(e) {
			}
			self.callHandler();
			self.close();
		} else {
			editor.win.focus();
			tmt.focus();
		}
		return false;
	};
	div.appendChild(this.doc.createTextNode(" "));
	btn = arguments[1];
	button = this.doc.createElement("button");
	div.appendChild(button);
	button.innerHTML = fMessage("cancel");
	button.onclick = function() {
		try{
	  		editor.win=null;
		}catch(e) {
		}
		self.close();
		editor.focusEditor();
		return false;
	};

};

PopupWin.prototype.showAtElement = function() {
	var self = this;
  	setTimeout(function() {
		var mv=navigator.appMinorVersion;
		var mz=self.doc.getElementsByName("f_mozzila")[0];
		var ie=self.doc.getElementsByName("f_iexplorer")[0];
		var w = self.content.offsetWidth + 4;
		var h = self.content.offsetHeight + 4;
		var el = self.content;
		var s = el.style;
		s.position = "absolute";
		s.left = (w - el.offsetWidth) / 2 + "px";
		s.top = (h - el.offsetHeight) / 2 + "px";
		if (HTMLArea.is_gecko) {
	  		self.window.innerWidth = w;
	  		self.window.innerHeight = h;
	  		self.window.moveTo(340, 210);
		} else {
	  		if(/sp2/i.test(mv)) {
				self.window.resizeTo(w + 8, parseInt(ie.value)+24);
	  		} else {
				self.window.resizeTo(w + 8, ie.value);
	  		}
		}
  	}, 25);
};