DROP TABLE IF EXISTS sb_logged_users
CREATE TABLE sb_logged_users (id integer auto_increment PRIMARY KEY, user_id integer NOT NULL default 0,  SID varchar(100) NOT NULL default '', expiretime varchar(50) NOT NULL default '') 
CREATE INDEX id_sb_logged_users ON sb_logged_users(id)

DROP TABLE IF EXISTS sb_ftphosts
CREATE TABLE sb_ftphosts ( id integer auto_increment PRIMARY KEY, ftp_host varchar(128) NOT NULL default '', ftp_host_ip varchar(128) default '', ftp_host_type integer NOT NULL default '1', ftp_host_ip_sec varchar(128) NOT NULL default '0', range integer NOT NULL default '0', number int(3) NOT NULL default '1',owner integer  NOT NULL default '1')
CREATE INDEX id_sb_ftphosts ON sb_ftphosts(id)
CREATE INDEX ftp_host ON sb_ftphosts(ftp_host)
CREATE INDEX owner ON sb_ftphosts(owner)

DROP TABLE IF EXISTS sb_resellers_items
CREATE TABLE sb_resellers_items (id integer auto_increment PRIMARY KEY,id_section int(1),id_item integer  NOT NULL,id_reseller int(10)  NOT NULL)
CREATE INDEX id_sb_resellers_items ON sb_resellers_items(id)
CREATE INDEX item ON sb_resellers_items(id_section,id_item)
CREATE INDEX reseller ON sb_resellers_items(id_reseller)

DROP TABLE IF EXISTS sb_profiles
CREATE TABLE sb_profiles ( id integer auto_increment PRIMARY KEY, user_id integer NOT NULL default '0', fname text NOT NULL, lname text NOT NULL,  address1 varchar(120) default NULL,  address2 varchar(120) NOT NULL default '',  phone varchar(20) default NULL,  email varchar(120) NOT NULL default '',  lang varchar(6) NOT NULL default 'en_US',  city varchar(40) NOT NULL default '',  state varchar(40) NOT NULL default '',  zip varchar(15) NOT NULL default '',  country int(3) NOT NULL default '0',  dquote int(7) NOT NULL default '100000',  ftp_host_id int(10)  default NULL,  ftp_work_dir varchar(128) default '') 
CREATE INDEX id_sb_profiles ON sb_profiles(id)

DROP TABLE IF EXISTS sb_users
CREATE TABLE sb_users ( id integer auto_increment PRIMARY KEY, login varchar(255) NOT NULL default '', pswd varchar(128) NOT NULL default '', role int(2) NOT NULL default '0', createtime varchar(20), sb_type integer NOT NULL default '1')
CREATE INDEX id_sb_users ON sb_users(id)
CREATE INDEX login ON sb_users(login)

DROP TABLE IF EXISTS sb_events
CREATE TABLE sb_events (id integer auto_increment PRIMARY KEY, user_id integer NOT NULL default '0', module varchar(20) NOT NULL default '', time varchar(20) NOT NULL default '', type integer NOT NULL default '0', eventtext varchar(255) NOT NULL default '') 
CREATE INDEX id_sb_events ON sb_events(id)

DROP TABLE IF EXISTS sb_events_history
CREATE TABLE sb_events_history (id integer  auto_increment PRIMARY KEY, user_id integer NOT NULL default '0', module varchar(20) NOT NULL default '', time varchar(20) NOT NULL default '', type integer NOT NULL default '0', eventtext varchar(255) NOT NULL default '') 
CREATE INDEX id_sb_events_history ON sb_events_history(id)

DROP TABLE IF EXISTS sb_msgs
CREATE TABLE sb_msgs (id integer auto_increment PRIMARY KEY, uid_from integer NOT NULL default '0',  uid_to integer NOT NULL default '0',  type tinyint(2) NOT NULL default '0',  message varchar(255) NOT NULL default '',  confirm tinyint(1) NOT NULL default '0',  createtime varchar(20) NOT NULL default '') 
CREATE INDEX id_sb_msgs ON sb_msgs(id)

DROP TABLE IF EXISTS sb_msgs_history
CREATE TABLE sb_msgs_history (id integer auto_increment PRIMARY KEY,  uid_from integer NOT NULL default '0',  uid_to integer NOT NULL default '0',  type tinyint(2) NOT NULL default '0',  message varchar(255) NOT NULL default '',  confirm tinyint(1) NOT NULL default '0',  createtime varchar(20) NOT NULL default '') 
CREATE INDEX id_sb_msgs_history ON sb_msgs_history(id)

DROP TABLE IF EXISTS sb_guestproj
CREATE TABLE sb_guestproj(id integer auto_increment PRIMARY KEY, dirname varchar(100) NOT NULL default '',expire varchar(50) NOT NULL default '',site_identety varchar(100) NOT NULL default '',is_user tinyint(1) NOT NULL default '0',perms integer NOT NULL default '1',reseller integer  NOT NULL default '1')
CREATE INDEX id_sb_guestproj ON sb_guestproj(id)
CREATE INDEX byReseller ON sb_guestproj(reseller)

DROP TABLE IF EXISTS sb_settings
CREATE TABLE sb_settings (id integer auto_increment PRIMARY KEY, prop_name varchar(50) NOT NULL, prop_value text NOT NULL, parent integer  NOT NULL default 1)
CREATE INDEX id_sb_settings ON sb_settings(id)
CREATE UNIQUE INDEX prop_name ON sb_settings(prop_name,parent) 
CREATE INDEX parent ON sb_settings(parent)

DROP TABLE IF EXISTS sb_db_version
CREATE TABLE sb_db_version ( value varchar(10) NOT NULL default '1' )

DROP TABLE IF EXISTS sb_userdirs
CREATE TABLE sb_userdirs ( id integer auto_increment PRIMARY KEY, user_id integer NOT NULL , dirname VARCHAR( 255 ) NOT NULL )
CREATE INDEX id_sb_userdirs ON sb_userdirs(id)

DROP TABLE IF EXISTS sb_templates
CREATE TABLE sb_templates(id integer auto_increment PRIMARY KEY, name varchar(255) default NULL, category varchar(255) default NULL,  state int(1) default NULL, attributes blob, category_id int(3) NOT NULL default '-1')
CREATE INDEX id_sb_templates ON sb_templates(id)
CREATE UNIQUE INDEX name ON sb_templates(name)

DROP TABLE IF EXISTS sb_site_profile
CREATE TABLE sb_site_profile ( id integer auto_increment PRIMARY KEY, id_parent varchar(100) NOT NULL default '', param varchar(50) default NULL, value varchar(255) default NULL)
CREATE INDEX id_sb_site_profile ON sb_site_profile(id)

DROP TABLE IF EXISTS sb_modules
CREATE TABLE sb_modules ( id integer auto_increment PRIMARY KEY, module_id varchar(30) NOT NULL default '', module_type varchar(30) NOT NULL default '', label varchar(255) NOT NULL default '', caption text NOT NULL, version varchar(15) NOT NULL default '', parent varchar(30) NOT NULL default '', state int(1) NOT NULL default '1', edit int(1) default '0', modules_api_version varchar(15) NOT NULL default '')
CREATE INDEX id_sb_modules ON sb_modules(id)
CREATE UNIQUE INDEX module_id ON sb_modules(module_id)

DROP TABLE IF EXISTS sb_plan
CREATE TABLE sb_plan (id_plan integer auto_increment PRIMARY KEY, active int(1) NOT NULL default '0', name varchar(255) NOT NULL default '', bknumber int(2) NOT NULL default '0', pubnumber int(2) NOT NULL default '0', pagenumber int(2) NOT NULL default '0', dquote int(7) NOT NULL default '0', is_guest int(1) NOT NULL default '0', descr varchar(128) default NULL, owner integer  NOT NULL default '1', rev_date varchar(50) NOT NULL default '0', rev_num varchar(50) NOT NULL default '0',plan_alias varchar(64) not null default 'BasePlan_alias')
CREATE INDEX id_sb_plan ON sb_plan(id_plan)
CREATE INDEX plan_owner ON sb_plan(owner)

DROP TABLE IF EXISTS sb_plan_prop
CREATE TABLE sb_plan_prop (id integer auto_increment PRIMARY KEY, id_tab1 integer NOT NULL default '0', id_tab2 integer NOT NULL default '0', id_rec1 integer NOT NULL default '0', id_rec2 integer NOT NULL default '0', userpart int(1)  NOT NULL default '0')
CREATE INDEX id_sb_plan_prop ON sb_plan_prop(id)

DROP TABLE IF EXISTS sb_resellers
CREATE TABLE sb_resellers(id int  auto_increment PRIMARY KEY, domain varchar(255) NOT NULL, email varchar(128) NOT NULL, name varchar(60) NOT NULL, limit_sites int DEFAULT '-1' NOT NULL, limit_hosts int DEFAULT '-1' NOT NULL)
CREATE INDEX id_sb_resellers ON sb_resellers(id)
CREATE UNIQUE INDEX byDomain ON sb_resellers(domain)

DROP TABLE IF EXISTS sb_stat_referers
CREATE TABLE sb_stat_referers ( id bigint(20)  auto_increment PRIMARY KEY, id_site bigint(20)  NOT NULL default '0', referer varchar(100) NOT NULL default '')
CREATE INDEX id_sb_stat_referers ON sb_stat_referers(id)

DROP TABLE IF EXISTS sb_stat_site_pages_1
CREATE TABLE sb_stat_site_pages_1 ( id bigint(20) auto_increment PRIMARY KEY, id_site bigint(20)  NOT NULL default '0', visitor_id bigint(20)  NOT NULL default '0',  page_name varchar(100) NOT NULL default '',  time bigint(20)  NOT NULL default '0' )
CREATE INDEX id_sb_stat_site_pages_1 ON sb_stat_site_pages_1(id)

DROP TABLE IF EXISTS sb_stat_site_pages_2
CREATE TABLE sb_stat_site_pages_2 ( id bigint(20)  auto_increment PRIMARY KEY, id_site bigint(20)  NOT NULL default '0', visitor_id bigint(20)  NOT NULL default '0',  page_name varchar(100) NOT NULL default '',  time bigint(20)  NOT NULL default '0' )
CREATE INDEX id_sb_stat_site_pages_2 ON sb_stat_site_pages_2(id)

DROP TABLE IF EXISTS sb_stat_visitors_1
CREATE TABLE sb_stat_visitors_1 ( id bigint(20)  auto_increment PRIMARY KEY, id_site bigint(20)  NOT NULL default '0', ip_real varchar(15) NOT NULL default '', ip_proxy varchar(15) default NULL, os_name tinyint(2)  NOT NULL default '0', br_name tinyint(2)  NOT NULL default '0', resolution tinyint(2)  NOT NULL default '0', cookie_use tinyint(1)  NOT NULL default '0', colors_bits tinyint(4)  NOT NULL default '0', javascript_use tinyint(1)  NOT NULL default '0', country char(3) NOT NULL default '')
CREATE INDEX id_sb_stat_visitors_1 ON sb_stat_visitors_1(id)

DROP TABLE IF EXISTS sb_stat_visitors_2
CREATE TABLE sb_stat_visitors_2 ( id bigint(20)  auto_increment PRIMARY KEY, id_site bigint(20)  NOT NULL default '0', ip_real varchar(15) NOT NULL default '', ip_proxy varchar(15) default NULL, os_name tinyint(2)  NOT NULL default '0', br_name tinyint(2)  NOT NULL default '0', resolution tinyint(2)  NOT NULL default '0', cookie_use tinyint(1)  NOT NULL default '0', colors_bits tinyint(4)  NOT NULL default '0', javascript_use tinyint(1)  NOT NULL default '0', country char(3) NOT NULL default '')
CREATE INDEX id_sb_stat_visitors_2 ON sb_stat_visitors_2(id)

DROP TABLE IF EXISTS sb_stat_report_option
CREATE TABLE sb_stat_report_option ( id integer  auto_increment PRIMARY KEY, period varchar(10) NOT NULL default '', stat_interval varchar(4) default NULL, lifetime varchar(4) default NULL, used tinyint(1)  NOT NULL default '0')
CREATE INDEX id_sb_stat_report_option ON sb_stat_report_option(id)

DROP TABLE IF EXISTS sb_stat_report_attendance
CREATE TABLE sb_stat_report_attendance (id integer auto_increment PRIMARY KEY, id_site integer NOT NULL default '0', total_hosts integer NOT NULL default '0', total_cookie_use integer NOT NULL default '0', total_js_use integer NOT NULL default '0',total_proxy integer NOT NULL default '0',hosts_by_time text NOT NULL,hits_by_time text NOT NULL,session_by_time text NOT NULL,date_start int(10) default NULL,date_end int(10) default NULL,stat_interval char(1) NOT NULL default '', period tinyint(1) NOT NULL default '0')
CREATE INDEX id_sb_stat_report_attendance ON sb_stat_report_attendance(id)

DROP TABLE IF EXISTS sb_stat_report_pages
CREATE TABLE sb_stat_report_pages (id integer auto_increment PRIMARY KEY, id_site integer NOT NULL default '0', name varchar(100) NOT NULL default '', total integer NOT NULL default '0', input_count integer NOT NULL default '0', output_count integer NOT NULL default '0', date_start int(10) default NULL, date_end int(10) default NULL, period tinyint(1) NOT NULL default '0')
CREATE INDEX id_sb_stat_report_pages ON sb_stat_report_pages(id)

DROP TABLE IF EXISTS sb_stat_report_settings
CREATE TABLE sb_stat_report_settings (id integer auto_increment PRIMARY KEY, id_site integer NOT NULL default '0', os_name text NOT NULL, br_name text NOT NULL, resolution text NOT NULL, color_bits text NOT NULL, country text NOT NULL, depth_page text NOT NULL, visit_time text NOT NULL, date_start int(10) default '0', date_end int(10) default '0', period tinyint(1) NOT NULL default '0')
CREATE INDEX id_sb_stat_report_settings ON sb_stat_report_settings(id)

DROP TABLE IF EXISTS sb_categories
CREATE TABLE sb_categories ( id integer auto_increment PRIMARY KEY, name varchar(80) NOT NULL default '')
CREATE INDEX id_sb_categories ON sb_categories(id)

DROP TABLE IF EXISTS sb_backup_settings
CREATE TABLE  sb_backup_settings(id integer auto_increment PRIMARY KEY, prop_name varchar(50) NOT NULL default '',  prop_value text NOT NULL) 
CREATE INDEX id_sb_backup_settings ON sb_backup_settings(id)
CREATE UNIQUE INDEX backup_prop_name ON sb_backup_settings(prop_name)
