<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"> 
<!-- 
	MSIE | MOZILLA | OPERA 
-->
<xsl:param name="browser" select="'MSIE'"/>
<xsl:param name="language" select="'en_US'"/>
<xsl:param name="title_sitebuilder" select="''"/>
<xsl:param name="baseURL" select="''"/>
<xsl:param name="baseURL_SUFFIX" select="''"/>
<xsl:param name="systemLOGO" select="''"/>
<xsl:param name="heightLOGO" select="''"/>
<xsl:param name="widthLOGO" select="''"/>
<xsl:param name="sid" select="'xxxxxx'"/>
<xsl:param name="admincp" select="'0'"/>

<xsl:variable name="sb_skin" select="/*/SKIN"/>
<xsl:strip-space elements="*"/>
<xsl:output method="html" indent="yes" encoding="utf-8"/>

<xsl:template match="/">
	<html>
		<head>
			<link rel="shortcut icon" href="{$baseURL}/favicon.ico" />
			<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
			<xsl:choose>
				<xsl:when test="$title_sitebuilder!=''">
					<title><xsl:value-of select="$title_sitebuilder" disable-output-escaping="yes"/></title>
				</xsl:when>
				<xsl:otherwise>
					<title>Sitebuilder</title>
				</xsl:otherwise>
		</xsl:choose>
		<xsl:call-template name="style-css"/>
		</head>	
		<body class="SB_Style_login_body" bgcolor="white">
			<xsl:apply-templates select="SITEBUILDER-PAGE"/>
		</body>
	</html>
</xsl:template>


<xsl:template match="SKIN">
</xsl:template>



<xsl:template match="MESSAGE" mode="CRITICAL-ERROR">
	<xsl:value-of select="." disable-output-escaping="yes"/>
	<xsl:if test="position() != last()">
		<br/>
	</xsl:if>
</xsl:template>


<xsl:template match="CRITICAL-ERROR">
	<table align="center" cellpadding="10" cellspacing="10" width="100%" height="100%" border="0">
		<tr>
			<td align="center">
				<table width="50%" border="0" cellspacing="10" cellpadding="0" class="SB_Style_WARNING_BOX">
					<tr>
						<td width="70px" align="center" valign="top">
							<img border="0" src="{$baseURL}/skins/{$sb_skin}/images/demo_publish.gif"/>
						</td>
						<td width="282px" valign="top" align="center">
							<table width="282px" cellspacing="0" cellpadding="0" border="0" style="padding-left: 16px; padding-right: 16px;">
								<tr>
									<td height="44px" width="250px" class="SB_Style_design_text">
										<xsl:if test="TITLE">
											<h4><xsl:value-of select="TITLE" disable-output-escaping="yes"/></h4>
										</xsl:if>
										<xsl:apply-templates select="MESSAGE" mode="CRITICAL-ERROR"/>
									</td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</xsl:template>

<xsl:template name="style-css">
<link rel="stylesheet" type="text/css" href="{$baseURL}/skins/{$sb_skin}/style.css"/>
<xsl:choose>
<xsl:when test="$language='he_IL'">
<link rel="stylesheet" type="text/css" href="{$baseURL}/skins/{$sb_skin}/style_rtl.css"/>
</xsl:when>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>