<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"> 
<xsl:include href="gui.xsl"/>
<!-- 
	MSIE | MOZILLA | OPERA 
-->
<xsl:param name="language" select="'en_US'"/>
<xsl:param name="browser" select="'MSIE'"/>
<xsl:param name="title_sitebuilder" select="''"/>
<xsl:param name="baseURL" select="''"/>
<xsl:param name="baseURL_SUFFIX" select="''"/>
<xsl:param name="systemLOGO" select="''"/>
<xsl:param name="heightLOGO" select="''"/>
<xsl:param name="widthLOGO" select="''"/>
<xsl:param name="sid" select="'xxxxxx'"/>
<xsl:param name="admincp" select="'0'"/>

<xsl:variable name="sb_skin" select="/*/SKIN"/>
<xsl:strip-space elements="*"/>
<xsl:output method="html" indent="yes" encoding="utf-8"/>
<xsl:include href="common.xsl"/>

<xsl:template match="/">
<xsl:value-of select="$html4.doctype" disable-output-escaping="yes"/>
<html>
<head>
<link rel="shortcut icon" href="{$baseURL}/favicon.ico" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

<xsl:choose>
<xsl:when test="$title_sitebuilder!=''">
<title><xsl:value-of select="$title_sitebuilder" disable-output-escaping="yes"/></title>
</xsl:when>

<xsl:otherwise>
<title>Sitebuilder</title>
</xsl:otherwise>
</xsl:choose>

<xsl:call-template name="style-css"/>
<script type="text/javascript"	language="javascript">
<xsl:comment>
var __sid = '<xsl:value-of select="$sid"/>';
var __base__URL = '<xsl:value-of select="$baseURL"/>';
var __base__URL_SUFFIX = '<xsl:value-of select="$baseURL_SUFFIX"/>';
var __sb_skin = '<xsl:value-of select="$sb_skin"/>';
//</xsl:comment>
</script> 
<script	type="text/javascript" language="javascript" src='{$baseURL}/js/login.js'></script>
<script type="text/javascript" language="JavaScript"><xsl:comment>
<xsl:if test="$browser='MOZILLA'">document.captureEvents( Event.KEYPRESS );</xsl:if>
document.onKeyPress = doVerify;
//</xsl:comment>
</script>
</head>	
<body class="SB_Style_login_body" bgcolor="white">
	<xsl:apply-templates select="SITEBUILDER-PAGE"/>
</body>
</html>
</xsl:template>
<!--
/////
-->
<xsl:template match="SITEBUILDER-PAGE">
<table cellpadding="0" cellspacing="0"  height="100%" border="0" width="100%">
<tr>
	<td height="40">
		<table border="0" cellpadding="0" cellspacing="0" width="100%" background="{$baseURL}/skins/{$sb_skin}/images/header_bg.gif" >
			<tr align="left">
				<td valign="top" width="130"><img src="{$baseURL}/images/{$systemLOGO}" border="0" align="center">
						<xsl:if test="$heightLOGO!=''"><xsl:attribute name="height"><xsl:value-of select="$heightLOGO"/></xsl:attribute></xsl:if>
						<xsl:if test="$widthLOGO!=''"><xsl:attribute name="width"><xsl:value-of select="$widthLOGO"/></xsl:attribute></xsl:if>
				</img></td>
			</tr>
		</table>
	</td>
</tr>
<tr class="SB_Style_login_PAGE">
	<td align="center"><xsl:apply-templates select="GUI-FORM[@TYPE='admin_login' or @TYPE='site_login' or @TYPE='site_pswd']"/></td>
</tr>
	<tr height="22"  valign="middle" align="middle">
		<td class="SB_copyright">
			<xsl:apply-templates select="SWSOFT" /><xsl:apply-templates select="CUSTOM-BRANDING"/>
		</td>
	</tr>

</table>
</xsl:template>

<xsl:template match="GUI-FORM[@TYPE='admin_login' or @TYPE='site_login' or @TYPE='site_pswd']">
	<!--<xsl:variable name="siteIdentity" select="FIELD[@NAME='sb_site_identity']"/>-->
	<fieldset class="SB_Style_fieldset_set">
		<table cellpadding="5" cellspacing="0" width="210px" valign="top" border="0" align="center" class="SB_Style_pageform">
			<form> 
				<xsl:apply-templates select="GUI-FORM-ATTRIBUTE"/> 
				<xsl:call-template name="AUTOCOMPLETE"/> 
				<xsl:if test="DESCRIPTION/WARNING">
					<tr>
						<td colspan="2">
							<xsl:apply-templates select="DESCRIPTION/WARNING"/>
						</td>
					</tr>
				</xsl:if>
				<xsl:apply-templates select="GUI-CONTROL[@MODE!='BUTTON']"/>
				<tr>
					<td colspan="2" align="right">
						<xsl:apply-templates select="GUI-CONTROL[@MODE='BUTTON']"/>
					</td>
				</tr>
			</form>
		</table>
	</fieldset>
</xsl:template>



</xsl:stylesheet>