#!/bin/sh

if [ "X$1" != "X" ]; then
	PATH_TO_CONFIG=$1
else
	PATH_TO_CONFIG='./'
fi

if [ -f ${PATH_TO_CONFIG}backup_cfg.txt ]; then

    . ${PATH_TO_CONFIG}backup_cfg.txt

    mkdir -p ${BACKUP_PATH}

    cd ${BACKUP_PATH}

    echo Begin backup process
    g_ret=0

    # backup SB Data Base
    if [ $DB -eq 1 ]; then

    	ret=0
#    	index=0
		backup_udb_list=`echo "$BACKUP_DB_LIST" | awk -F':' '{if (\$2 != ""){print \$1}else{print \$1}}' | awk 'BEGIN {RS="[ \t\r\n]+"} {a = $1; sub("^!", "", a); line[a] = a} END {for (a in line) print a}'`
#		declare -a backup_udb_list
#		for cur_db in $BACKUP_DB_LIST; do
#		cur_db=`echo "$cur_db" | awk -F':' '{if (\$2 != ""){print \$1}else{print \$1}}'`
#		grep_flag=`echo "$cur_db"| grep '!'`
#
#		if [ -n "$grep_flag" ]; then
#			cur_db=`expr substr $cur_db  2 ${#cur_db}`
#		fi
#		add_flag=1
#		for val in $backup_udb_list; do
#			if [ "_$cur_db" = "_$val" ]; then
#				add_flag=0
#			fi
#		done
#		if [ $add_flag -gt 0 ]; then
#			backup_udb_list[$index]=$cur_db
#		fi
#		let "index=$index + 1"
#		done

		for cur_db in $backup_udb_list; do

		if [ -n "$cur_db" ]; then

			for cur_db_table in `${PATH_TO_MYSQL}mysqlshow --user=${DB_USER} --password=${DB_PASSWD} $cur_db| tr -d ' |'|grep -v -E '^Tables$|^Database\:|^\+\-\-\-'`; do

				flag=1
				for cur_ignore in $BACKUP_DB_LIST; do
				    if [ "_$cur_ignore" = "_!$cur_db:$cur_db_table" ]; then
						flag=0
				    fi
				done

				if [ $flag -gt 0 ]; then
				    echo "Dumping $cur_db:$cur_db_table..."
				    ${PATH_TO_MYSQL}mysqldump ${PARAM} --user=${DB_USER} --password=${DB_PASSWD} $cur_db $cur_db_table >> ${cur_db}.sql

		    	    if [ $? -ne 0 ]; then
	    		    	ret=1
		    	    fi 
				else
				    echo "Skiping $cur_db:$cur_db_table..."
				fi

				flagweb=0
				for cur_ignore in $BACKUP_DB_LIST_WEB; do
				    if [ "_$cur_ignore" = "_$cur_db:$cur_db_table" ]; then
						flagweb=1
				    fi
				done

				if [ $flagweb -gt 0 ]; then
				    ${PATH_TO_MYSQL}mysqldump ${PARAM} --user=${DB_USER} --password=${DB_PASSWD} $cur_db $cur_db_table >> web_${cur_db}.sql
		    	    if [ $? -ne 0 ]; then
	    		    	ret=1
		    	    fi 
				fi

			done

    	fi
		done


   		tar -cf ${BACKUP_PATH}/${FILE_FORMAT}.tar *.sql
        if [ $? -ne 0 ]; then
   	    	ret=1
        fi 
   		chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
   	    if [ $? -ne 0 -o $ret -ne 0 ]; then
        	echo "Create database backup...failed"
   	    	g_ret=1
        else
       		echo "Create database backup...ok"
   	    fi 
    	rm *.sql 

    	# backup SB Settings
    	${PATH_TO_MYSQL}mysql --user=${DB_USER} --password=${DB_PASSWD} -e "use ${SB_DB_NAME};select prop_name, prop_value from sb_settings where 1" > ${BACKUP_PATH}/sb_settings.tmp

    	SB_LANGS=`awk '/^sb_language/ {print $2}' ${BACKUP_PATH}/sb_settings.tmp`
#    	SB_LANGS=(${SB_LANGS})

    	if [ ${#SB_LANGS[@]} -gt 0 ]; then

#    		for i in ${SB_LANGS[@]}
    		for i in ${SB_LANGS}		
    		do

    			ret=0
    			if [ -e ${LANG_PATH}$i -a ! -e ${BACKUP_PATH}/sb_lang/$i ]; then
       				mkdir -p ${BACKUP_PATH}/sb_lang
    			    cp -p -R ${LANG_PATH}$i ${BACKUP_PATH}/sb_lang
    		    	if [ $? -ne 0 ]; then
    			    	ret=1
    			    fi 
    			    cd ${BACKUP_PATH}
    			    tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_lang/$i
    			    if [ $? -ne 0 ]; then
        				ret=1
    			    fi 
    			    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
    			    if [ $? -ne 0 -o $ret -ne 0 ]; then
    	    			echo "Create language ($i) backup...failed"
    			    	g_ret=1
    			    else
    			    	echo "Create language ($i) backup...ok"
    			    fi 
    			fi
    		done
    		rm -rf ${BACKUP_PATH}/sb_lang

    	fi

    	SB_SKINS=`awk '/^sb_skin/ {print $2}' ${BACKUP_PATH}/sb_settings.tmp`
#    	SB_SKINS=(${SB_SKINS})

    	if [ ${#SB_SKINS[@]} -gt 0 ]; then

#    		for i in ${SB_SKINS[@]}
    		for i in ${SB_SKINS}		
    		do
        	    ret=0
        		if [ -e ${SKIN_PATH}$i -a ! -e ${BACKUP_PATH}/sb_skin/$i ]; then
           			mkdir -p ${BACKUP_PATH}/sb_skin
        		    cp -p -R ${SKIN_PATH}$i ${BACKUP_PATH}/sb_skin
        		    if [ $? -ne 0 ]; then
            			ret=1
        		    fi 
        		    cd ${BACKUP_PATH}
        		    tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_skin/$i
        		    if [ $? -ne 0 ]; then
            			ret=1
        		    fi 
        		    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
        		    if [ $? -ne 0 -o $ret -ne 0 ]; then
        	    		echo "Create skin ($i) backup...failed"
        		    	g_ret=1
        		    else
        		    	echo "Create skin ($i) backup...ok"
        		    fi 
        		fi

    		done
       		rm -rf ${BACKUP_PATH}/sb_skin

    	fi



    	SB_LOGOS=`awk '/^currentSystemLogo/ {print $2 }' ${BACKUP_PATH}/sb_settings.tmp`
#    	SB_LOGOS=(${SB_LOGOS})

    	if [ ${#SB_LOGOS[@]} -gt 0 ]; then

#    		for i in ${SB_LOGOS[@]}
    		for i in ${SB_LOGOS}		
    		do

        	    ret=0
        		if [ -f ${IMG_PATH}$i -a ! -e ${BACKUP_PATH}/sb_logo/$i ]; then
           			mkdir -p ${BACKUP_PATH}/sb_logo
        		    cp -p ${IMG_PATH}$i ${BACKUP_PATH}/sb_logo/$i
        		    if [ $? -ne 0 ]; then
            			ret=1
        		    fi 
        		    cd ${BACKUP_PATH}
        		    tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_logo/$i
        		    if [ $? -ne 0 ]; then
            			ret=1
        		    fi 
        		    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
        		    if [ $? -ne 0 -o $ret -ne 0 ]; then
        	    		echo "Create logo ($i) backup...failed"
        		    	g_ret=1
        		    else
        		    	echo "Create logo ($i) backup...ok"
        		    fi 

        		fi
        	    
    		done

       		rm -rf ${BACKUP_PATH}/sb_logo

    	fi

    	rm -rf ${BACKUP_PATH}/sb_settings.tmp
    	
    fi

    # backup User dir and Guest dir
    if [ $USER_DIR -eq 1 -o $GUEST_DIR -eq 1 ]; then
    	EMPTY=`ls -la ${SOURCE_DIR}| wc -l`
    	if [ $EMPTY -ne 3 ]; then
    		ret=0
    		cd ${SOURCE_DIR}
    		tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar *
    	    if [ $? -ne 0 ]; then
       			ret=1
    	    fi 
    		chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
    	    if [ $? -ne 0 -o $ret -ne 0 ]; then
        		echo "Create user(guest) catalogues backup...failed"
    	    	g_ret=1
    	    else
    	    	echo "Create user(guest) catalogues backup...ok"
    	    fi 
    	fi
    fi

    # backup Page Sests

    # active
    if [ -e ${APSETS_PATH} ]; then
    	ret=0
    	EMPTY=`ls -la ${APSETS_PATH}| wc -l`
    	if [ $EMPTY -ne 3 ]; then

    		mkdir -p ${BACKUP_PATH}/sb_psets/active
        	cp -p -R ${APSETS_PATH}* ${BACKUP_PATH}/sb_psets/active
    	    if [ $? -ne 0 ]; then
    			ret=1
    	    fi 
        	cd ${BACKUP_PATH}
    	    tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_psets/active
        	if [ $? -ne 0 ]; then
    			ret=1
        	fi 
    	    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
    	    if [ $? -ne 0 -o $ret -ne 0 ]; then
       			echo "Create active Pagesets backup...failed"
        		g_ret=1
    	    else
        		echo "Create active Pagesets backup...ok"
    	    fi 

    	fi
    fi

    # non active
    if [ -e ${DPSETS_PATH} ]; then
    	ret=0
    	EMPTY=`ls -la ${DPSETS_PATH}| wc -l`
    	if [ $EMPTY -ne 3 ]; then

    		mkdir -p ${BACKUP_PATH}/sb_psets/dactive
        	cp -p -R ${DPSETS_PATH}* ${BACKUP_PATH}/sb_psets/dactive
    	    if [ $? -ne 0 ]; then
    			ret=1
    	    fi 
    	    cd ${BACKUP_PATH}
    	   	tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_psets/dactive
    	    if [ $? -ne 0 ]; then
    			ret=1
        	fi 
    	    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
        	if [ $? -ne 0 -o $ret -ne 0 ]; then
    	   		echo "Create non-active Pagesets backup...failed"
        		g_ret=1
    	    else
        		echo "Create non-active Pagesets backup...ok"
    	    fi 

    	fi
    fi
    rm -rf ${BACKUP_PATH}/sb_psets

    EMPTY=`ls -la $PATH_TO_MODULES| wc -l`
    if [ $EMPTY -ne 3 ]; then

    	mkdir -p ${BACKUP_PATH}/sb_modules

    	MODULESLIST=`ls $PATH_TO_MODULES`
#    	MODULES_ARR=(${MODULESLIST});


#    	for i in "${MODULES_ARR[@]}"
    	for i in "${MODULES_ARR}"	
    	do
    		if [ -d $PATH_TO_MODULES/$i/config  ]; then
    			mkdir -p ${BACKUP_PATH}/sb_modules/$i/config
    			cp -p -R $PATH_TO_MODULES/$i/config/* ${BACKUP_PATH}/sb_modules/$i/config
       		    if [ $? -ne 0 ]; then
           			ret=1
       		    fi 
       		    cd ${BACKUP_PATH}
       		    tar -X ${EXCLUDE_FILE} -rf ${BACKUP_PATH}/${FILE_FORMAT}.tar ./sb_modules/$i/config
       		    if [ $? -ne 0 ]; then
           			ret=1
       		    fi 
       		    chmod 600 ${BACKUP_PATH}/${FILE_FORMAT}.tar
       		    if [ $? -ne 0 -o $ret -ne 0 ]; then
       	    		echo "Create backup configuration file $i module...failed"
       		    	g_ret=1
       		    else
       		    	echo "Create backup configuration file $i module...ok"
       		    fi 

    		fi	
    	done

    	rm -rf ${BACKUP_PATH}/sb_modules
    fi

    if [ -f ${BACKUP_PATH}/${FILE_FORMAT}.tar ]; then
    	gzip ${BACKUP_PATH}/${FILE_FORMAT}.tar
    fi
else
	echo Configuration file has not been found.
	g_ret=1
fi

if [ -f ${BACKUP_PATH}/${FILE_FORMAT}.tar.gz -a $g_ret -eq 0 ]; then
	echo Backup is successfully completed. Path to the backup file:${BACKUP_PATH}/${FILE_FORMAT}.tar.gz
else
	echo Backup is completed with errors.
	if [ -f ${BACKUP_PATH}/${FILE_FORMAT}.tar.gz ]; then
		echo Path to the backup file:${BACKUP_PATH}/${FILE_FORMAT}.tar.gz
	fi
fi
